Add utility function to recognize upgrade ranges
[ganeti-local] / Makefile.am
1 # Ganeti makefile
2 # - Indent with tabs only.
3 # - Keep files sorted; one line per file.
4 # - Directories in lib/ must have their own *dir variable (see hypervisor).
5 # - All directories must be listed DIRS.
6 # - Use autogen.sh to generate Makefile.in and configure script.
7
8 # Automake doesn't export these variables before version 1.10.
9 abs_top_builddir = @abs_top_builddir@
10 abs_top_srcdir = @abs_top_srcdir@
11
12 # Helper values for calling builtin functions
13 empty :=
14 space := $(empty) $(empty)
15 comma := ,
16
17 # Helper function to strip src/ and test/hs/ from a list
18 strip_hsroot = $(patsubst src/%,%,$(patsubst test/hs/%,%,$(1)))
19
20 # Use bash in order to be able to use pipefail
21 SHELL=/bin/bash
22
23 # Enable colors in shelltest
24 SHELLTESTARGS = "-c"
25
26 ACLOCAL_AMFLAGS = -I autotools
27 BUILD_BASH_COMPLETION = $(top_srcdir)/autotools/build-bash-completion
28 RUN_IN_TEMPDIR = $(top_srcdir)/autotools/run-in-tempdir
29 CHECK_PYTHON_CODE = $(top_srcdir)/autotools/check-python-code
30 CHECK_HEADER = $(top_srcdir)/autotools/check-header
31 CHECK_MAN_DASHES = $(top_srcdir)/autotools/check-man-dashes
32 CHECK_MAN_REFERENCES = $(top_srcdir)/autotools/check-man-references
33 CHECK_MAN_WARNINGS = $(top_srcdir)/autotools/check-man-warnings
34 CHECK_VERSION = $(top_srcdir)/autotools/check-version
35 CHECK_NEWS = $(top_srcdir)/autotools/check-news
36 CHECK_IMPORTS = $(top_srcdir)/autotools/check-imports
37 DOCPP = $(top_srcdir)/autotools/docpp
38 REPLACE_VARS_SED = autotools/replace_vars.sed
39 CONVERT_CONSTANTS = $(top_srcdir)/autotools/convert-constants
40 BUILD_RPC = $(top_srcdir)/autotools/build-rpc
41 SHELL_ENV_INIT = autotools/shell-env-init
42
43 # starting as of Ganeti 2.10, all files are stored in two directories,
44 # with only symbolic links added at other places.
45 #
46 # $(versiondir) contains most of Ganeti and all architecture-dependent files
47 # $(versionedsharedir) contains only architecture-independent files; all python
48 # executables need to go directly to $(versionedsharedir), as all ganeti python
49 # mdules are installed outside the usual python path, i.e., as private modules.
50 #
51 # $(defaultversiondir) and $(defaultversionedsharedir) are the corresponding
52 # directories for "the currently running" version of Ganeti. We never install
53 # there, but all symbolic links go there, rather than directory to $(versiondir)
54 # or $(versionedsharedir). Note that all links to $(default*dir) need to be stable;
55 # so, if some currently architecture-independent executable is replaced by an
56 # architecture-dependent one (and hence has to go under $(versiondir)), add a link
57 # under $(versionedsharedir) but do not change the external links.
58 if USE_VERSION_FULL
59 DIRVERSION=$(VERSION_FULL)
60 else
61 DIRVERSION=$(VERSION_MAJOR).$(VERSION_MINOR)
62 endif
63 versiondir = $(libdir)/ganeti/$(DIRVERSION)
64 defaultversiondir = $(libdir)/ganeti/default
65 versionedsharedir = $(prefix)/share/ganeti/$(DIRVERSION)
66 defaultversionedsharedir = $(prefix)/share/ganeti/default
67
68
69 # Note: these are automake-specific variables, and must be named after
70 # the directory + 'dir' suffix
71 pkglibdir = $(versiondir)$(libdir)/ganeti
72 myexeclibdir = $(pkglibdir)
73 bindir = $(versiondir)$(exec_prefix)/bin
74 sbindir = $(versiondir)$(exec_prefix)/sbin
75 mandir = $(versionedsharedir)$(datarootdir)/man
76 pkgpythondir = $(versionedsharedir)/ganeti
77 gntpythondir = $(versionedsharedir)
78 pkgpython_bindir = $(versionedsharedir)
79 gnt_python_sbindir = $(versionedsharedir)
80 tools_pythondir = $(versionedsharedir)
81
82 clientdir = $(pkgpythondir)/client
83 cmdlibdir = $(pkgpythondir)/cmdlib
84 hypervisordir = $(pkgpythondir)/hypervisor
85 storagedir = $(pkgpythondir)/storage
86 httpdir = $(pkgpythondir)/http
87 masterddir = $(pkgpythondir)/masterd
88 confddir = $(pkgpythondir)/confd
89 rapidir = $(pkgpythondir)/rapi
90 serverdir = $(pkgpythondir)/server
91 watcherdir = $(pkgpythondir)/watcher
92 impexpddir = $(pkgpythondir)/impexpd
93 utilsdir = $(pkgpythondir)/utils
94 toolsdir = $(pkglibdir)/tools
95 iallocatorsdir = $(pkglibdir)/iallocators
96 pytoolsdir = $(pkgpythondir)/tools
97 docdir = $(versiondir)$(datadir)/doc/$(PACKAGE)
98
99 SYMLINK_TARGET_DIRS = \
100         $(sysconfdir)/ganeti \
101         $(libdir)/ganeti/iallocators \
102         $(libdir)/ganeti/tools \
103         $(prefix)/share/ganeti \
104         $(exec_prefix)/bin \
105         $(exec_prefix)/sbin \
106         $(datarootdir)/man/man1 \
107         $(datarootdir)/man/man7 \
108         $(datarootdir)/man/man8
109
110 # Delete output file if an error occurred while building it
111 .DELETE_ON_ERROR:
112
113 HS_DIRS = \
114         src \
115         src/Ganeti \
116         src/Ganeti/Confd \
117         src/Ganeti/Curl \
118         src/Ganeti/Cpu \
119         src/Ganeti/DataCollectors \
120         src/Ganeti/Hs2Py \
121         src/Ganeti/HTools \
122         src/Ganeti/HTools/Backend \
123         src/Ganeti/HTools/Program \
124         src/Ganeti/Hypervisor \
125         src/Ganeti/Hypervisor/Xen \
126         src/Ganeti/Monitoring \
127         src/Ganeti/Query \
128         src/Ganeti/Storage \
129         src/Ganeti/Storage/Diskstats \
130         src/Ganeti/Storage/Drbd \
131         src/Ganeti/Storage/Lvm \
132         test/hs \
133         test/hs/Test \
134         test/hs/Test/Ganeti \
135         test/hs/Test/Ganeti/Storage \
136         test/hs/Test/Ganeti/Storage/Diskstats \
137         test/hs/Test/Ganeti/Storage/Drbd \
138         test/hs/Test/Ganeti/Storage/Lvm \
139         test/hs/Test/Ganeti/Confd \
140         test/hs/Test/Ganeti/HTools \
141         test/hs/Test/Ganeti/HTools/Backend \
142         test/hs/Test/Ganeti/Hypervisor \
143         test/hs/Test/Ganeti/Hypervisor/Xen \
144         test/hs/Test/Ganeti/Query
145
146 # Haskell directories without the roots (src, test/hs)
147 HS_DIRS_NOROOT = $(filter-out src,$(filter-out test/hs,$(HS_DIRS)))
148
149 DIRS = \
150         $(HS_DIRS) \
151         autotools \
152         daemons \
153         devel \
154         devel/data \
155         doc \
156         doc/css \
157         doc/examples \
158         doc/examples/gnt-debug \
159         doc/examples/hooks \
160         doc/users \
161         test/data/htools \
162         test/data/htools/rapi \
163         test/hs/shelltests \
164         test/autotools \
165         lib \
166         lib/build \
167         lib/client \
168         lib/cmdlib \
169         lib/confd \
170         lib/http \
171         lib/hypervisor \
172         lib/impexpd \
173         lib/masterd \
174         lib/rapi \
175         lib/server \
176         lib/storage \
177         lib/tools \
178         lib/utils \
179         lib/watcher \
180         man \
181         qa \
182         test \
183         test/data \
184         test/data/bdev-rbd \
185         test/data/ovfdata \
186         test/data/ovfdata/other \
187         test/py \
188         test/py/cmdlib \
189         test/py/cmdlib/testsupport \
190         tools
191
192 ALL_APIDOC_HS_DIRS = \
193         $(APIDOC_HS_DIR) \
194         $(patsubst %,$(APIDOC_HS_DIR)/%,$(call strip_hsroot,$(HS_DIRS_NOROOT)))
195
196 BUILDTIME_DIR_AUTOCREATE = \
197         scripts \
198         $(APIDOC_DIR) \
199         $(ALL_APIDOC_HS_DIRS) \
200         $(APIDOC_PY_DIR) \
201         $(COVERAGE_DIR) \
202         $(COVERAGE_HS_DIR) \
203         $(COVERAGE_PY_DIR) \
204         .hpc
205
206 BUILDTIME_DIRS = \
207         $(BUILDTIME_DIR_AUTOCREATE) \
208         doc/html \
209         doc/man-html
210
211 DIRCHECK_EXCLUDE = \
212         $(BUILDTIME_DIRS) \
213         ganeti-[0-9]*.[0-9]*.[0-9]* \
214         doc/html/_* \
215         doc/man-html/_* \
216         autom4te.cache
217
218 # some helper vars
219 COVERAGE_DIR = doc/coverage
220 COVERAGE_PY_DIR = $(COVERAGE_DIR)/py
221 COVERAGE_HS_DIR = $(COVERAGE_DIR)/hs
222 APIDOC_DIR = doc/api
223 APIDOC_PY_DIR = $(APIDOC_DIR)/py
224 APIDOC_HS_DIR = $(APIDOC_DIR)/hs
225
226 MAINTAINERCLEANFILES = \
227         $(maninput) \
228         doc/install-quick.rst \
229         doc/news.rst \
230         doc/upgrade.rst \
231         vcs-version
232
233 maintainer-clean-local:
234         rm -rf $(BUILDTIME_DIRS)
235
236 CLEANFILES = \
237         $(addsuffix /*.py[co],$(DIRS)) \
238         $(addsuffix /*.hi,$(HS_DIRS)) \
239         $(addsuffix /*.o,$(HS_DIRS)) \
240         $(PYTHON_BOOTSTRAP) \
241         $(gnt_python_sbin_SCRIPTS) \
242         epydoc.conf \
243         $(REPLACE_VARS_SED) \
244         $(SHELL_ENV_INIT) \
245         daemons/daemon-util \
246         daemons/ganeti-cleaner \
247         devel/squeeze-amd64.tar.gz \
248         devel/squeeze-amd64.conf \
249         $(mandocrst) \
250         doc/manpages-enabled.rst \
251         $(BUILT_EXAMPLES) \
252         doc/examples/bash_completion \
253         doc/examples/bash_completion-debug \
254         $(userspecs) \
255         lib/_generated_rpc.py \
256         $(man_MANS) \
257         $(manhtml) \
258         tools/kvm-ifup \
259         tools/vif-ganeti \
260         tools/net-common \
261         tools/users-setup \
262         tools/vcluster-setup \
263         stamp-directories \
264         stamp-srclinks \
265         $(nodist_pkgpython_PYTHON) \
266         $(gnt_scripts) \
267         $(HS_ALL_PROGS) $(HS_BUILT_SRCS) \
268         $(HS_BUILT_TEST_HELPERS) \
269         src/ganeti-confd \
270         src/ganeti-luxid \
271         src/ganeti-mond \
272         src/hs2py-constants \
273         .hpc/*.mix src/*.tix test/hs/*.tix *.tix \
274         doc/hs-lint.html
275
276 GENERATED_FILES = \
277         $(built_base_sources) \
278         $(BUILT_PYTHON_SOURCES) \
279         $(PYTHON_BOOTSTRAP) \
280         $(gnt_python_sbin_SCRIPTS)
281
282 HS_GENERATED_FILES =
283 if WANT_HTOOLS
284 HS_GENERATED_FILES += $(HS_PROGS)
285 if ENABLE_CONFD
286 HS_GENERATED_FILES += src/hconfd src/ganeti-confd src/hluxid src/ganeti-luxid
287 endif
288
289 if ENABLE_MOND
290 HS_GENERATED_FILES += src/ganeti-mond
291 endif
292 endif
293
294 built_base_sources = \
295         stamp-directories \
296         stamp-srclinks
297
298 built_python_base_sources = \
299         lib/_constants.py \
300         lib/_vcsversion.py \
301         lib/opcodes.py
302
303 BUILT_PYTHON_SOURCES = \
304         $(built_python_base_sources) \
305         lib/_generated_rpc.py
306
307 # Generating the RPC wrappers depends on many things, so make sure
308 # it's built at the end of the built sources
309 lib/_generated_rpc.py: | $(built_base_sources) $(built_python_base_sources)
310
311 # these are all built from the underlying %.in sources
312 BUILT_EXAMPLES = \
313         doc/examples/ganeti-kvm-poweroff.initd \
314         doc/examples/ganeti.cron \
315         doc/examples/ganeti.initd \
316         doc/examples/ganeti.logrotate \
317         doc/examples/ganeti-master-role.ocf \
318         doc/examples/ganeti-node-role.ocf \
319         doc/examples/gnt-config-backup \
320         doc/examples/hooks/ipsec
321
322 nodist_pkgpython_PYTHON = \
323         $(BUILT_PYTHON_SOURCES)
324
325 nodist_pkgpython_bin_SCRIPTS = \
326         $(nodist_pkglib_python_scripts)
327
328 pkgpython_bin_SCRIPTS = \
329         $(pkglib_python_scripts)
330
331 noinst_PYTHON = \
332         lib/build/__init__.py \
333         lib/build/shell_example_lexer.py \
334         lib/build/sphinx_ext.py
335
336 pkgpython_PYTHON = \
337         lib/__init__.py \
338         lib/asyncnotifier.py \
339         lib/backend.py \
340         lib/bootstrap.py \
341         lib/cli.py \
342         lib/compat.py \
343         lib/config.py \
344         lib/constants.py \
345         lib/daemon.py \
346         lib/errors.py \
347         lib/hooksmaster.py \
348         lib/ht.py \
349         lib/jqueue.py \
350         lib/jstore.py \
351         lib/locking.py \
352         lib/luxi.py \
353         lib/mcpu.py \
354         lib/netutils.py \
355         lib/objects.py \
356         lib/opcodes_base.py \
357         lib/outils.py \
358         lib/ovf.py \
359         lib/pathutils.py \
360         lib/qlang.py \
361         lib/query.py \
362         lib/rpc.py \
363         lib/rpc_defs.py \
364         lib/runtime.py \
365         lib/serializer.py \
366         lib/ssconf.py \
367         lib/ssh.py \
368         lib/uidpool.py \
369         lib/vcluster.py \
370         lib/network.py \
371         lib/workerpool.py
372
373 client_PYTHON = \
374         lib/client/__init__.py \
375         lib/client/gnt_backup.py \
376         lib/client/gnt_cluster.py \
377         lib/client/gnt_debug.py \
378         lib/client/gnt_group.py \
379         lib/client/gnt_instance.py \
380         lib/client/gnt_job.py \
381         lib/client/gnt_node.py \
382         lib/client/gnt_network.py \
383         lib/client/gnt_os.py \
384         lib/client/gnt_storage.py
385
386 cmdlib_PYTHON = \
387         lib/cmdlib/__init__.py \
388         lib/cmdlib/backup.py \
389         lib/cmdlib/base.py \
390         lib/cmdlib/cluster.py \
391         lib/cmdlib/common.py \
392         lib/cmdlib/group.py \
393         lib/cmdlib/instance.py \
394         lib/cmdlib/instance_migration.py \
395         lib/cmdlib/instance_operation.py \
396         lib/cmdlib/instance_query.py \
397         lib/cmdlib/instance_storage.py \
398         lib/cmdlib/instance_utils.py \
399         lib/cmdlib/misc.py \
400         lib/cmdlib/network.py \
401         lib/cmdlib/node.py \
402         lib/cmdlib/operating_system.py \
403         lib/cmdlib/query.py \
404         lib/cmdlib/tags.py \
405         lib/cmdlib/test.py
406
407 hypervisor_PYTHON = \
408         lib/hypervisor/__init__.py \
409         lib/hypervisor/hv_base.py \
410         lib/hypervisor/hv_chroot.py \
411         lib/hypervisor/hv_fake.py \
412         lib/hypervisor/hv_kvm.py \
413         lib/hypervisor/hv_lxc.py \
414         lib/hypervisor/hv_xen.py
415
416 storage_PYTHON = \
417         lib/storage/__init__.py \
418         lib/storage/bdev.py \
419         lib/storage/base.py \
420         lib/storage/container.py \
421         lib/storage/drbd.py \
422         lib/storage/drbd_info.py \
423         lib/storage/drbd_cmdgen.py \
424         lib/storage/filestorage.py
425
426 rapi_PYTHON = \
427         lib/rapi/__init__.py \
428         lib/rapi/baserlib.py \
429         lib/rapi/client.py \
430         lib/rapi/client_utils.py \
431         lib/rapi/connector.py \
432         lib/rapi/rlib2.py \
433         lib/rapi/testutils.py
434
435 http_PYTHON = \
436         lib/http/__init__.py \
437         lib/http/auth.py \
438         lib/http/client.py \
439         lib/http/server.py
440
441 confd_PYTHON = \
442         lib/confd/__init__.py \
443         lib/confd/client.py
444
445 masterd_PYTHON = \
446         lib/masterd/__init__.py \
447         lib/masterd/iallocator.py \
448         lib/masterd/instance.py
449
450 impexpd_PYTHON = \
451         lib/impexpd/__init__.py
452
453 watcher_PYTHON = \
454         lib/watcher/__init__.py \
455         lib/watcher/nodemaint.py \
456         lib/watcher/state.py
457
458 server_PYTHON = \
459         lib/server/__init__.py \
460         lib/server/masterd.py \
461         lib/server/noded.py \
462         lib/server/rapi.py
463
464 pytools_PYTHON = \
465         lib/tools/__init__.py \
466         lib/tools/burnin.py \
467         lib/tools/ensure_dirs.py \
468         lib/tools/node_cleanup.py \
469         lib/tools/node_daemon_setup.py \
470         lib/tools/prepare_node_join.py
471
472 utils_PYTHON = \
473         lib/utils/__init__.py \
474         lib/utils/algo.py \
475         lib/utils/filelock.py \
476         lib/utils/hash.py \
477         lib/utils/io.py \
478         lib/utils/log.py \
479         lib/utils/lvm.py \
480         lib/utils/mlock.py \
481         lib/utils/nodesetup.py \
482         lib/utils/process.py \
483         lib/utils/retry.py \
484         lib/utils/storage.py \
485         lib/utils/text.py \
486         lib/utils/version.py \
487         lib/utils/wrapper.py \
488         lib/utils/x509.py
489
490 docinput = \
491         doc/conf.py \
492         doc/css/style.css \
493         doc/admin.rst \
494         doc/cluster-merge.rst \
495         doc/design-2.0.rst \
496         doc/design-2.1.rst \
497         doc/design-2.2.rst \
498         doc/design-2.3.rst \
499         doc/design-2.4.rst \
500         doc/design-2.5.rst \
501         doc/design-2.6.rst \
502         doc/design-2.7.rst \
503         doc/design-2.8.rst \
504         doc/design-2.9.rst \
505         doc/design-autorepair.rst \
506         doc/design-bulk-create.rst \
507         doc/design-chained-jobs.rst \
508         doc/design-cpu-pinning.rst \
509         doc/design-device-uuid-name.rst \
510         doc/design-draft.rst \
511         doc/design-hotplug.rst \
512         doc/design-glusterfs-ganeti-support.rst \
513         doc/design-daemons.rst \
514         doc/design-htools-2.3.rst \
515         doc/design-http-server.rst \
516         doc/design-impexp2.rst \
517         doc/design-internal-shutdown.rst \
518         doc/design-lu-generated-jobs.rst \
519         doc/design-linuxha.rst \
520         doc/design-multi-reloc.rst \
521         doc/design-network.rst \
522         doc/design-node-add.rst \
523         doc/design-oob.rst \
524         doc/design-openvswitch.rst \
525         doc/design-ovf-support.rst \
526         doc/design-opportunistic-locking.rst \
527         doc/design-optables.rst \
528         doc/design-partitioned.rst \
529         doc/design-query-splitting.rst \
530         doc/design-query2.rst \
531         doc/design-reason-trail.rst \
532         doc/design-resource-model.rst \
533         doc/design-restricted-commands.rst \
534         doc/design-shared-storage.rst \
535         doc/design-monitoring-agent.rst \
536         doc/design-virtual-clusters.rst \
537         doc/design-x509-ca.rst \
538         doc/design-hroller.rst \
539         doc/design-storagetypes.rst \
540         doc/design-upgrade.rst \
541         doc/devnotes.rst \
542         doc/glossary.rst \
543         doc/hooks.rst \
544         doc/iallocator.rst \
545         doc/index.rst \
546         doc/install-quick.rst \
547         doc/install.rst \
548         doc/locking.rst \
549         doc/manpages-disabled.rst \
550         doc/monitoring-query-format.rst \
551         doc/move-instance.rst \
552         doc/news.rst \
553         doc/ovfconverter.rst \
554         doc/rapi.rst \
555         doc/security.rst \
556         doc/upgrade.rst \
557         doc/virtual-cluster.rst \
558         doc/walkthrough.rst
559
560 # Generates file names such as "doc/man-gnt-instance.rst"
561 mandocrst = $(addprefix doc/man-,$(notdir $(manrst)))
562
563 # Haskell programs to be installed in $PREFIX/bin
564 HS_BIN_PROGS=src/htools
565
566 # Haskell programs to be installed in the MYEXECLIB dir
567 if ENABLE_MOND
568 HS_MYEXECLIB_PROGS=src/mon-collector
569 else
570 HS_MYEXECLIB_PROGS=
571 endif
572
573 # Haskell programs to be compiled by "make really-all"
574 HS_COMPILE_PROGS= \
575         src/ganeti-mond \
576         src/hconfd \
577         src/hluxid \
578         src/hs2py \
579         src/rpc-test
580
581 # All Haskell non-test programs to be compiled but not automatically installed
582 HS_PROGS = $(HS_BIN_PROGS) $(HS_MYEXECLIB_PROGS)
583
584 HS_BIN_ROLES = harep hbal hscan hspace hinfo hcheck hroller
585 HS_HTOOLS_PROGS = $(HS_BIN_ROLES) hail
586
587 # Haskell programs that cannot be disabled at configure (e.g., unlike
588 # 'mon-collector')
589 HS_DEFAULT_PROGS = \
590         $(HS_BIN_PROGS) \
591         test/hs/hpc-htools \
592         test/hs/hpc-mon-collector \
593         test/hs/htest \
594         $(HS_COMPILE_PROGS)
595
596 HS_ALL_PROGS = $(HS_DEFAULT_PROGS) $(HS_MYEXECLIB_PROGS)
597
598 HS_PROG_SRCS = $(patsubst %,%.hs,$(HS_DEFAULT_PROGS)) \
599                src/mon-collector.hs \
600                src/hs2py-constants.hs
601 HS_BUILT_TEST_HELPERS = $(HS_BIN_ROLES:%=test/hs/%) test/hs/hail
602
603 HFLAGS = \
604         -O -Wall -Werror -isrc \
605         -fwarn-monomorphism-restriction \
606         -fwarn-tabs \
607         $(GHC_BYVERSION_FLAGS)
608
609 # extra flags that can be overriden on the command line (e.g. -Wwarn, etc.)
610 HEXTRA =
611 # internal extra flags (used for test/hs/htest mainly)
612 HEXTRA_INT =
613 # exclude options for coverage reports
614 HPCEXCL = --exclude Main \
615         --exclude Ganeti.Constants \
616         --exclude Ganeti.HTools.QC \
617         --exclude Ganeti.THH \
618         --exclude Ganeti.Version \
619         --exclude Test.Ganeti.Attoparsec \
620         --exclude Test.Ganeti.TestCommon \
621         --exclude Test.Ganeti.TestHTools \
622         --exclude Test.Ganeti.TestHelper \
623         --exclude Test.Ganeti.TestImports \
624         $(patsubst src.%,--exclude Test.%,$(subst /,.,$(patsubst %.hs,%, $(HS_LIB_SRCS))))
625
626 HS_LIB_SRCS = \
627         src/Ganeti/BasicTypes.hs \
628         src/Ganeti/Common.hs \
629         src/Ganeti/Compat.hs \
630         src/Ganeti/Confd/Client.hs \
631         src/Ganeti/Confd/ClientFunctions.hs \
632         src/Ganeti/Confd/Server.hs \
633         src/Ganeti/Confd/Types.hs \
634         src/Ganeti/Confd/Utils.hs \
635         src/Ganeti/Config.hs \
636         src/Ganeti/ConfigReader.hs \
637         src/Ganeti/Constants.hs \
638         src/Ganeti/ConstantUtils.hs \
639         src/Ganeti/Cpu/LoadParser.hs \
640         src/Ganeti/Cpu/Types.hs \
641         src/Ganeti/Curl/Multi.hs \
642         src/Ganeti/Daemon.hs \
643         src/Ganeti/DataCollectors/CLI.hs \
644         src/Ganeti/DataCollectors/CPUload.hs \
645         src/Ganeti/DataCollectors/Diskstats.hs \
646         src/Ganeti/DataCollectors/Drbd.hs \
647         src/Ganeti/DataCollectors/InstStatus.hs \
648         src/Ganeti/DataCollectors/InstStatusTypes.hs \
649         src/Ganeti/DataCollectors/Lv.hs \
650         src/Ganeti/DataCollectors/Program.hs \
651         src/Ganeti/DataCollectors/Types.hs \
652         src/Ganeti/Errors.hs \
653         src/Ganeti/HTools/Backend/IAlloc.hs \
654         src/Ganeti/HTools/Backend/Luxi.hs \
655         src/Ganeti/HTools/Backend/Rapi.hs \
656         src/Ganeti/HTools/Backend/Simu.hs \
657         src/Ganeti/HTools/Backend/Text.hs \
658         src/Ganeti/HTools/CLI.hs \
659         src/Ganeti/HTools/Cluster.hs \
660         src/Ganeti/HTools/Container.hs \
661         src/Ganeti/HTools/ExtLoader.hs \
662         src/Ganeti/HTools/Graph.hs \
663         src/Ganeti/HTools/Group.hs \
664         src/Ganeti/HTools/Instance.hs \
665         src/Ganeti/HTools/Loader.hs \
666         src/Ganeti/HTools/Nic.hs \
667         src/Ganeti/HTools/Node.hs \
668         src/Ganeti/HTools/PeerMap.hs \
669         src/Ganeti/HTools/Program/Hail.hs \
670         src/Ganeti/HTools/Program/Harep.hs \
671         src/Ganeti/HTools/Program/Hbal.hs \
672         src/Ganeti/HTools/Program/Hcheck.hs \
673         src/Ganeti/HTools/Program/Hinfo.hs \
674         src/Ganeti/HTools/Program/Hscan.hs \
675         src/Ganeti/HTools/Program/Hspace.hs \
676         src/Ganeti/HTools/Program/Hroller.hs \
677         src/Ganeti/HTools/Program/Main.hs \
678         src/Ganeti/HTools/Types.hs \
679         src/Ganeti/Hypervisor/Xen.hs \
680         src/Ganeti/Hypervisor/Xen/XmParser.hs \
681         src/Ganeti/Hypervisor/Xen/Types.hs \
682         src/Ganeti/Hash.hs \
683         src/Ganeti/Hs2Py/GenConstants.hs \
684         src/Ganeti/Hs2Py/GenOpCodes.hs \
685         src/Ganeti/Hs2Py/OpDoc.hs \
686         src/Ganeti/HsConstants.hs \
687         src/Ganeti/JQueue.hs \
688         src/Ganeti/JSON.hs \
689         src/Ganeti/Jobs.hs \
690         src/Ganeti/Logging.hs \
691         src/Ganeti/Luxi.hs \
692         src/Ganeti/Monitoring/Server.hs \
693         src/Ganeti/Network.hs \
694         src/Ganeti/Objects.hs \
695         src/Ganeti/OpCodes.hs \
696         src/Ganeti/OpParams.hs \
697         src/Ganeti/Path.hs \
698         src/Ganeti/Parsers.hs \
699         src/Ganeti/PyValueInstances.hs \
700         src/Ganeti/Query/Cluster.hs \
701         src/Ganeti/Query/Common.hs \
702         src/Ganeti/Query/Export.hs \
703         src/Ganeti/Query/Filter.hs \
704         src/Ganeti/Query/Group.hs \
705         src/Ganeti/Query/Job.hs \
706         src/Ganeti/Query/Language.hs \
707         src/Ganeti/Query/Network.hs \
708         src/Ganeti/Query/Node.hs \
709         src/Ganeti/Query/Query.hs \
710         src/Ganeti/Query/Server.hs \
711         src/Ganeti/Query/Types.hs \
712         src/Ganeti/Rpc.hs \
713         src/Ganeti/Runtime.hs \
714         src/Ganeti/Ssconf.hs \
715         src/Ganeti/Storage/Diskstats/Parser.hs \
716         src/Ganeti/Storage/Diskstats/Types.hs \
717         src/Ganeti/Storage/Drbd/Parser.hs \
718         src/Ganeti/Storage/Drbd/Types.hs \
719         src/Ganeti/Storage/Lvm/LVParser.hs \
720         src/Ganeti/Storage/Lvm/Types.hs \
721         src/Ganeti/Storage/Utils.hs \
722         src/Ganeti/THH.hs \
723         src/Ganeti/Types.hs \
724         src/Ganeti/Utils.hs
725
726 HS_TEST_SRCS = \
727         test/hs/Test/Ganeti/Attoparsec.hs \
728         test/hs/Test/Ganeti/BasicTypes.hs \
729         test/hs/Test/Ganeti/Common.hs \
730         test/hs/Test/Ganeti/Confd/Types.hs \
731         test/hs/Test/Ganeti/Confd/Utils.hs \
732         test/hs/Test/Ganeti/Constants.hs \
733         test/hs/Test/Ganeti/Daemon.hs \
734         test/hs/Test/Ganeti/Errors.hs \
735         test/hs/Test/Ganeti/HTools/Backend/Simu.hs \
736         test/hs/Test/Ganeti/HTools/Backend/Text.hs \
737         test/hs/Test/Ganeti/HTools/CLI.hs \
738         test/hs/Test/Ganeti/HTools/Cluster.hs \
739         test/hs/Test/Ganeti/HTools/Container.hs \
740         test/hs/Test/Ganeti/HTools/ExtLoader.hs \
741         test/hs/Test/Ganeti/HTools/Graph.hs \
742         test/hs/Test/Ganeti/HTools/Instance.hs \
743         test/hs/Test/Ganeti/HTools/Loader.hs \
744         test/hs/Test/Ganeti/HTools/Node.hs \
745         test/hs/Test/Ganeti/HTools/PeerMap.hs \
746         test/hs/Test/Ganeti/HTools/Types.hs \
747         test/hs/Test/Ganeti/Hypervisor/Xen/XmParser.hs \
748         test/hs/Test/Ganeti/JSON.hs \
749         test/hs/Test/Ganeti/Jobs.hs \
750         test/hs/Test/Ganeti/JQueue.hs \
751         test/hs/Test/Ganeti/Luxi.hs \
752         test/hs/Test/Ganeti/Network.hs \
753         test/hs/Test/Ganeti/Objects.hs \
754         test/hs/Test/Ganeti/OpCodes.hs \
755         test/hs/Test/Ganeti/Query/Filter.hs \
756         test/hs/Test/Ganeti/Query/Language.hs \
757         test/hs/Test/Ganeti/Query/Network.hs \
758         test/hs/Test/Ganeti/Query/Query.hs \
759         test/hs/Test/Ganeti/Rpc.hs \
760         test/hs/Test/Ganeti/Runtime.hs \
761         test/hs/Test/Ganeti/Ssconf.hs \
762         test/hs/Test/Ganeti/Storage/Diskstats/Parser.hs \
763         test/hs/Test/Ganeti/Storage/Drbd/Parser.hs \
764         test/hs/Test/Ganeti/Storage/Drbd/Types.hs \
765         test/hs/Test/Ganeti/Storage/Lvm/LVParser.hs \
766         test/hs/Test/Ganeti/THH.hs \
767         test/hs/Test/Ganeti/TestCommon.hs \
768         test/hs/Test/Ganeti/TestHTools.hs \
769         test/hs/Test/Ganeti/TestHelper.hs \
770         test/hs/Test/Ganeti/Types.hs \
771         test/hs/Test/Ganeti/Utils.hs
772
773 HS_LIBTEST_SRCS = $(HS_LIB_SRCS) $(HS_TEST_SRCS)
774
775 HS_BUILT_SRCS = \
776         test/hs/Test/Ganeti/TestImports.hs \
777         src/AutoConf.hs \
778         src/Ganeti/Hs2Py/ListConstants.hs \
779         src/Ganeti/PyConstants.hs \
780         src/Ganeti/Curl/Internal.hs \
781         src/Ganeti/Version.hs
782 HS_BUILT_SRCS_IN = \
783         $(patsubst %,%.in,$(filter-out src/Ganeti/Curl/Internal.hs,$(HS_BUILT_SRCS))) \
784         src/Ganeti/Curl/Internal.hsc \
785         lib/_constants.py.in \
786         lib/opcodes.py.in_after \
787         lib/opcodes.py.in_before
788
789 HS_LIBTESTBUILT_SRCS = $(HS_LIBTEST_SRCS) $(HS_BUILT_SRCS)
790
791 $(RUN_IN_TEMPDIR): | stamp-directories
792
793 doc/html/index.html: ENABLE_MANPAGES =
794 doc/man-html/index.html: ENABLE_MANPAGES = 1
795 doc/man-html/index.html: doc/manpages-enabled.rst $(mandocrst)
796
797 # Note: we use here an order-only prerequisite, as the contents of
798 # _constants.py are not actually influencing the html build output: it
799 # has to exist in order for the sphinx module to be loaded
800 # successfully, but we certainly don't want the docs to be rebuilt if
801 # it changes
802 doc/html/index.html doc/man-html/index.html: $(docinput) doc/conf.py \
803         configure.ac $(RUN_IN_TEMPDIR) lib/build/sphinx_ext.py \
804         lib/build/shell_example_lexer.py lib/ht.py \
805         doc/css/style.css lib/rapi/connector.py lib/rapi/rlib2.py \
806         autotools/sphinx-wrapper | $(BUILT_PYTHON_SOURCES)
807         @test -n "$(SPHINX)" || \
808             { echo 'sphinx-build' not found during configure; exit 1; }
809 if !MANPAGES_IN_DOC
810         if test -n '$(ENABLE_MANPAGES)'; then \
811           echo 'Man pages in documentation were disabled at configure time' >&2; \
812           exit 1; \
813         fi
814 endif
815 ## Sphinx provides little control over what content should be included. Some
816 ## mechanisms exist, but they all have drawbacks or actual issues. Since we
817 ## build two different versions of the documentation--once without man pages and
818 ## once, if enabled, with them--some control is necessary. xmpp-wrapper provides
819 ## us with this, but requires running in a temporary directory. It moves the
820 ## correct files into place depending on environment variables.
821         dir=$(dir $@) && \
822         @mkdir_p@ $$dir && \
823         PYTHONPATH=. ENABLE_MANPAGES=$(ENABLE_MANPAGES) COPY_DOC=1 \
824         $(RUN_IN_TEMPDIR) autotools/sphinx-wrapper $(SPHINX) -q -W -b html \
825             -d . \
826             -D version="$(VERSION_MAJOR).$(VERSION_MINOR)" \
827             -D release="$(PACKAGE_VERSION)" \
828             -D graphviz_dot="$(DOT)" \
829             -D enable_manpages="$(ENABLE_MANPAGES)" \
830             doc $(CURDIR)/$$dir && \
831         rm -f $$dir/.buildinfo $$dir/objects.inv
832         touch $@
833
834 doc/html: doc/html/index.html
835
836 doc/man-html: doc/man-html/index.html
837
838 doc/install-quick.rst: INSTALL
839 doc/news.rst: NEWS
840 doc/upgrade.rst: UPGRADE
841
842 doc/install-quick.rst doc/news.rst doc/upgrade.rst:
843         set -e; \
844         { echo '.. This file is automatically updated at build time from $<.'; \
845           echo '.. Do not edit.'; \
846           echo; \
847           cat $<; \
848         } > $@
849
850 doc/manpages-enabled.rst: Makefile | $(built_base_sources)
851         { echo '.. This file is automatically generated, do not edit!'; \
852           echo ''; \
853           echo 'Man pages'; \
854           echo '========='; \
855           echo; \
856           echo '.. toctree::'; \
857           echo '   :maxdepth: 1'; \
858           echo; \
859           for i in $(notdir $(mandocrst)); do \
860             echo "   $$i"; \
861           done | LC_ALL=C sort; \
862         } > $@
863
864 doc/man-%.rst: man/%.gen Makefile $(REPLACE_VARS_SED) | $(built_base_sources)
865 if MANPAGES_IN_DOC
866         { echo '.. This file is automatically updated at build time from $<.'; \
867           echo '.. Do not edit.'; \
868           echo; \
869           echo "$*"; \
870           echo '=========================================='; \
871           tail -n +3 $< | sed -f $(REPLACE_VARS_SED); \
872         } > $@
873 else
874         echo 'Man pages in documentation were disabled at configure time' >&2; \
875         exit 1;
876 endif
877
878 doc/users/%: doc/users/%.in Makefile $(REPLACE_VARS_SED)
879         cat $< | sed -f $(REPLACE_VARS_SED) | LC_ALL=C sort | uniq | (grep -v '^root' || true) > $@
880
881 userspecs = \
882         doc/users/users \
883         doc/users/groups \
884         doc/users/groupmemberships
885
886 # Things to build but not to install (add it to EXTRA_DIST if it should be
887 # distributed)
888 noinst_DATA = \
889         $(BUILT_EXAMPLES) \
890         doc/examples/bash_completion \
891         doc/examples/bash_completion-debug \
892         $(userspecs) \
893         $(manhtml)
894
895 if HAS_SPHINX
896 if MANPAGES_IN_DOC
897 noinst_DATA += doc/man-html
898 else
899 noinst_DATA += doc/html
900 endif
901 endif
902
903 gnt_scripts = \
904         scripts/gnt-backup \
905         scripts/gnt-cluster \
906         scripts/gnt-debug \
907         scripts/gnt-group \
908         scripts/gnt-instance \
909         scripts/gnt-job \
910         scripts/gnt-network \
911         scripts/gnt-node \
912         scripts/gnt-os \
913         scripts/gnt-storage
914
915 gnt_scripts_basenames = \
916         $(patsubst scripts/%,%,$(patsubst daemons/%,%,$(gnt_scripts) $(gnt_python_sbin_SCRIPTS)))
917
918 gnt_python_sbin_SCRIPTS = \
919         $(PYTHON_BOOTSTRAP_SBIN)
920
921 gntpython_SCRIPTS = $(gnt_scripts)
922
923 PYTHON_BOOTSTRAP_SBIN = \
924         daemons/ganeti-masterd \
925         daemons/ganeti-noded \
926         daemons/ganeti-rapi \
927         daemons/ganeti-watcher
928
929 PYTHON_BOOTSTRAP = \
930         tools/burnin \
931         tools/ensure-dirs \
932         tools/node-cleanup \
933         tools/node-daemon-setup \
934         tools/prepare-node-join
935
936 qa_scripts = \
937         qa/__init__.py \
938         qa/ganeti-qa.py \
939         qa/qa_cluster.py \
940         qa/qa_config.py \
941         qa/qa_daemon.py \
942         qa/qa_env.py \
943         qa/qa_error.py \
944         qa/qa_group.py \
945         qa/qa_instance.py \
946         qa/qa_instance_utils.py \
947         qa/qa_job.py \
948         qa/qa_monitoring.py \
949         qa/qa_node.py \
950         qa/qa_os.py \
951         qa/qa_rapi.py \
952         qa/qa_tags.py \
953         qa/qa_utils.py
954
955 bin_SCRIPTS =
956 if WANT_HTOOLS
957 bin_SCRIPTS += $(HS_BIN_PROGS)
958 install-exec-hook:
959         @mkdir_p@ $(DESTDIR)$(iallocatorsdir)
960 # FIXME: this is a hardcoded logic, instead of auto-resolving
961         $(LN_S) -f ../../../bin/htools \
962           $(DESTDIR)$(iallocatorsdir)/hail
963         for role in $(HS_BIN_ROLES); do \
964           $(LN_S) -f htools $(DESTDIR)$(bindir)/$$role ; \
965         done
966 endif
967
968 # This target cannot be merged with the '$(HS_ALL_PROGS)' target
969 # because 'hs2py-constants' cannot depend on 'Ganeti.Constants'.  And
970 # the reason for this is because 'hs2py-constants' needs to generate
971 # Python code, and 'Ganeti.Constants' is generated by Python.
972 src/hs2py-constants: src/hs2py-constants.hs src/AutoConf.hs \
973                      src/Ganeti/BasicTypes.hs src/Ganeti/ConstantUtils.hs \
974                      src/Ganeti/JSON.hs src/Ganeti/THH.hs \
975                      src/Ganeti/Hs2Py/GenConstants.hs \
976                      src/Ganeti/Hs2Py/ListConstants.hs \
977                      src/Ganeti/HsConstants.hs \
978                      src/Ganeti/PyValueInstances.hs \
979                    | stamp-srclinks
980         $(GHC) --make \
981           $(HFLAGS) \
982           -osuf $(notdir $@).o -hisuf $(notdir $@).hi \
983           $(HEXTRA) $(HEXTRA_INT) src/hs2py-constants.hs
984
985 $(HS_ALL_PROGS): %: %.hs $(HS_LIBTESTBUILT_SRCS) Makefile
986         @if [ "$(notdir $@)" = "test" ] && [ "$(HS_NODEV)" ]; then \
987           echo "Error: cannot run unittests without the development" \
988                " libraries (see devnotes.rst)" 1>&2; \
989           exit 1; \
990         fi
991         @rm -f $(notdir $@).tix
992         $(GHC) --make \
993           $(HFLAGS) \
994           $(HS_PARALLEL3) $(HS_REGEX_PCRE) \
995           -osuf $(notdir $@).o -hisuf $(notdir $@).hi \
996           $(HEXTRA) $(HEXTRA_INT) $@
997         @touch "$@"
998
999 # for the test/hs/htest binary, we need to enable profiling/coverage
1000 test/hs/htest: HEXTRA_INT=-fhpc -itest/hs
1001
1002 # we compile the hpc-htools binary with the program coverage
1003 test/hs/hpc-htools: HEXTRA_INT=-fhpc
1004
1005 # we compile the hpc-mon-collector binary with the program coverage
1006 test/hs/hpc-mon-collector: HEXTRA_INT=-fhpc
1007
1008 # test dependency
1009 test/hs/offline-test.sh: test/hs/hpc-htools test/hs/hpc-mon-collector
1010
1011 # rules for building profiling-enabled versions of the haskell
1012 # programs: hs-prof does the full two-step build, whereas
1013 # hs-prof-quick does only the final rebuild (hs-prof must have been
1014 # run before)
1015 .PHONY: hs-prof hs-prof-quick
1016 hs-prof:
1017         @if [ -z "$(TARGET)" ]; then \
1018           echo "You need to define TARGET when running this rule" 1>&2; \
1019           exit 1; \
1020         fi
1021         $(MAKE) $(AM_MAKEFLAGS) clean
1022         $(MAKE) $(AM_MAKEFLAGS) $(TARGET) HEXTRA="-osuf o"
1023         rm -f $(HS_ALL_PROGS)
1024         $(MAKE) $(AM_MAKEFLAGS) hs-prof-quick
1025
1026 hs-prof-quick:
1027         @if [ -z "$(TARGET)" ]; then \
1028           echo "You need to define TARGET when running this rule" 1>&2; \
1029           exit 1; \
1030         fi
1031         $(MAKE) $(AM_MAKEFLAGS) $(TARGET) HEXTRA="-osuf prof_o -prof -auto-all"
1032
1033 dist_sbin_SCRIPTS = \
1034         tools/ganeti-listrunner
1035
1036 nodist_sbin_SCRIPTS = \
1037         daemons/ganeti-cleaner
1038
1039 # strip path prefixes off the sbin scripts
1040 all_sbin_scripts = \
1041         $(patsubst tools/%,%,$(patsubst daemons/%,%,$(patsubst scripts/%,%,\
1042         $(patsubst src/%,%,$(dist_sbin_SCRIPTS) $(nodist_sbin_SCRIPTS)))))
1043
1044 if ENABLE_CONFD
1045 src/ganeti-confd: src/hconfd
1046         cp -f $< $@
1047
1048 src/ganeti-luxid: src/hluxid
1049         cp -f $< $@
1050
1051 nodist_sbin_SCRIPTS += src/ganeti-confd
1052 nodist_sbin_SCRIPTS += src/ganeti-luxid
1053 endif
1054
1055 if ENABLE_MOND
1056 nodist_sbin_SCRIPTS += src/ganeti-mond
1057 endif
1058
1059 python_scripts = \
1060         tools/cfgshell \
1061         tools/cfgupgrade \
1062         tools/cfgupgrade12 \
1063         tools/cluster-merge \
1064         tools/confd-client \
1065         tools/fmtjson \
1066         tools/lvmstrap \
1067         tools/move-instance \
1068         tools/ovfconverter \
1069         tools/sanitize-config
1070
1071 dist_tools_SCRIPTS = \
1072         tools/kvm-console-wrapper \
1073         tools/master-ip-setup \
1074         tools/xen-console-wrapper
1075
1076 dist_tools_python_SCRIPTS = \
1077         $(python_scripts) \
1078         tools/burnin
1079
1080 nodist_tools_python_SCRIPTS = \
1081         tools/node-cleanup
1082
1083 tools_python_basenames = $(patsubst tools/%,%,\
1084         $(dist_tools_python_SCRIPTS) $(nodist_tools_python_SCRIPTS))
1085
1086 nodist_tools_SCRIPTS = \
1087         tools/users-setup \
1088         tools/vcluster-setup
1089
1090 tools_basenames = $(patsubst tools/%,%,$(nodist_tools_SCRIPTS) $(dist_tools_SCRIPTS))
1091
1092 pkglib_python_scripts = \
1093         daemons/import-export \
1094         tools/check-cert-expired
1095
1096 nodist_pkglib_python_scripts = \
1097         tools/ensure-dirs \
1098         tools/node-daemon-setup \
1099         tools/prepare-node-join
1100
1101 pkglib_python_basenames = \
1102         $(patsubst daemons/%,%,$(patsubst tools/%,%,\
1103         $(pkglib_python_scripts) $(nodist_pkglib_python_scripts)))
1104
1105 myexeclib_SCRIPTS = \
1106         daemons/daemon-util \
1107         tools/kvm-ifup \
1108         tools/vif-ganeti \
1109         tools/net-common \
1110         $(HS_MYEXECLIB_PROGS)
1111
1112 # compute the basenames of the myexeclib_scripts
1113 myexeclib_scripts_basenames = \
1114         $(patsubst tools/%,%,$(patsubst daemons/%,%,$(patsubst src/%,%,$(myexeclib_SCRIPTS))))
1115
1116 EXTRA_DIST = \
1117         NEWS \
1118         UPGRADE \
1119         epydoc.conf.in \
1120         pylintrc \
1121         pylintrc-test \
1122         autotools/build-bash-completion \
1123         autotools/build-rpc \
1124         autotools/check-header \
1125         autotools/check-imports \
1126         autotools/check-man-dashes \
1127         autotools/check-man-references \
1128         autotools/check-man-warnings \
1129         autotools/check-news \
1130         autotools/check-python-code \
1131         autotools/check-tar \
1132         autotools/check-version \
1133         autotools/convert-constants \
1134         autotools/docpp \
1135         autotools/gen-py-coverage \
1136         autotools/sphinx-wrapper \
1137         autotools/testrunner \
1138         autotools/wrong-hardcoded-paths \
1139         $(RUN_IN_TEMPDIR) \
1140         daemons/daemon-util.in \
1141         daemons/ganeti-cleaner.in \
1142         $(pkglib_python_scripts) \
1143         devel/upload \
1144         devel/webserver \
1145         tools/kvm-ifup.in \
1146         tools/vif-ganeti.in \
1147         tools/net-common.in \
1148         tools/vcluster-setup.in \
1149         $(docinput) \
1150         doc/html \
1151         $(BUILT_EXAMPLES:%=%.in) \
1152         doc/examples/ganeti.default \
1153         doc/examples/ganeti.default-debug \
1154         doc/examples/hooks/ethers \
1155         doc/examples/gnt-debug/README \
1156         doc/examples/gnt-debug/delay0.json \
1157         doc/examples/gnt-debug/delay50.json \
1158         doc/users/groupmemberships.in \
1159         doc/users/groups.in \
1160         doc/users/users.in \
1161         $(dist_TESTS) \
1162         $(TEST_FILES) \
1163         $(python_test_support) \
1164         man/footer.rst \
1165         $(manrst) \
1166         $(maninput) \
1167         qa/qa-sample.json \
1168         $(qa_scripts) \
1169         $(HS_LIBTEST_SRCS) $(HS_BUILT_SRCS_IN) \
1170         $(HS_PROG_SRCS) \
1171         src/lint-hints.hs \
1172         test/hs/cli-tests-defs.sh \
1173         test/hs/offline-test.sh \
1174         .ghci
1175
1176 man_MANS = \
1177         man/ganeti-cleaner.8 \
1178         man/ganeti-confd.8 \
1179         man/ganeti-luxid.8 \
1180         man/ganeti-listrunner.8 \
1181         man/ganeti-masterd.8 \
1182         man/ganeti-mond.8 \
1183         man/ganeti-noded.8 \
1184         man/ganeti-os-interface.7 \
1185         man/ganeti-extstorage-interface.7 \
1186         man/ganeti-rapi.8 \
1187         man/ganeti-watcher.8 \
1188         man/ganeti.7 \
1189         man/gnt-backup.8 \
1190         man/gnt-cluster.8 \
1191         man/gnt-debug.8 \
1192         man/gnt-group.8 \
1193         man/gnt-network.8 \
1194         man/gnt-instance.8 \
1195         man/gnt-job.8 \
1196         man/gnt-node.8 \
1197         man/gnt-os.8 \
1198         man/gnt-storage.8 \
1199         man/hail.1 \
1200         man/harep.1 \
1201         man/hbal.1 \
1202         man/hcheck.1 \
1203         man/hinfo.1 \
1204         man/hscan.1 \
1205         man/hspace.1 \
1206         man/hroller.1 \
1207         man/htools.1 \
1208         man/mon-collector.7
1209
1210 # Remove extensions from all filenames in man_MANS
1211 mannoext = $(patsubst %.1,%,$(patsubst %.7,%,$(patsubst %.8,%,$(man_MANS))))
1212
1213 manrst = $(patsubst %,%.rst,$(mannoext))
1214 manhtml = $(patsubst %.rst,%.html,$(manrst))
1215 mangen = $(patsubst %.rst,%.gen,$(manrst))
1216 maninput = \
1217         $(patsubst %.1,%.1.in,$(patsubst %.7,%.7.in,$(patsubst %.8,%.8.in,$(man_MANS)))) \
1218         $(patsubst %.html,%.html.in,$(manhtml)) \
1219         $(mangen)
1220
1221 manfullpath = $(patsubst man/%.1,man1/%.1,\
1222         $(patsubst man/%.7,man7/%.7,\
1223         $(patsubst man/%.8,man8/%.8,$(man_MANS))))
1224
1225 TEST_FILES = \
1226         test/autotools/autotools-check-news.test \
1227         test/data/htools/clean-nonzero-score.data \
1228         test/data/htools/common-suffix.data \
1229         test/data/htools/empty-cluster.data \
1230         test/data/htools/hail-alloc-drbd.json \
1231         test/data/htools/hail-alloc-invalid-network.json \
1232         test/data/htools/hail-alloc-invalid-twodisks.json \
1233         test/data/htools/hail-alloc-restricted-network.json \
1234         test/data/htools/hail-alloc-spindles.json \
1235         test/data/htools/hail-alloc-twodisks.json \
1236         test/data/htools/hail-change-group.json \
1237         test/data/htools/hail-invalid-reloc.json \
1238         test/data/htools/hail-node-evac.json \
1239         test/data/htools/hail-reloc-drbd.json \
1240         test/data/htools/hbal-dyn.data \
1241         test/data/htools/hbal-excl-tags.data \
1242         test/data/htools/hbal-split-insts.data \
1243         test/data/htools/hspace-tiered-dualspec-exclusive.data \
1244         test/data/htools/hspace-tiered-dualspec.data \
1245         test/data/htools/hspace-tiered-exclusive.data \
1246         test/data/htools/hspace-tiered-ipolicy.data \
1247         test/data/htools/hspace-tiered-mixed.data \
1248         test/data/htools/hspace-tiered-resourcetypes.data \
1249         test/data/htools/hspace-tiered-vcpu.data \
1250         test/data/htools/hspace-tiered.data \
1251         test/data/htools/invalid-node.data \
1252         test/data/htools/missing-resources.data \
1253         test/data/htools/multiple-master.data \
1254         test/data/htools/multiple-tags.data \
1255         test/data/htools/n1-failure.data \
1256         test/data/htools/rapi/groups.json \
1257         test/data/htools/rapi/info.json \
1258         test/data/htools/rapi/instances.json \
1259         test/data/htools/rapi/nodes.json \
1260         test/data/htools/hroller-full.data \
1261         test/data/htools/hroller-nodegroups.data \
1262         test/data/htools/hroller-nonredundant.data \
1263         test/data/htools/hroller-online.data \
1264         test/data/htools/unique-reboot-order.data \
1265         test/hs/shelltests/htools-balancing.test \
1266         test/hs/shelltests/htools-basic.test \
1267         test/hs/shelltests/htools-dynutil.test \
1268         test/hs/shelltests/htools-excl.test \
1269         test/hs/shelltests/htools-hail.test \
1270         test/hs/shelltests/htools-hroller.test \
1271         test/hs/shelltests/htools-hspace.test \
1272         test/hs/shelltests/htools-invalid.test \
1273         test/hs/shelltests/htools-multi-group.test \
1274         test/hs/shelltests/htools-no-backend.test \
1275         test/hs/shelltests/htools-rapi.test \
1276         test/hs/shelltests/htools-single-group.test \
1277         test/hs/shelltests/htools-text-backend.test \
1278         test/hs/shelltests/htools-mon-collector.test \
1279         test/data/bdev-drbd-8.0.txt \
1280         test/data/bdev-drbd-8.3.txt \
1281         test/data/bdev-drbd-8.4.txt \
1282         test/data/bdev-drbd-8.4-no-disk-params.txt \
1283         test/data/bdev-drbd-disk.txt \
1284         test/data/bdev-drbd-net-ip4.txt \
1285         test/data/bdev-drbd-net-ip6.txt \
1286         test/data/bdev-rbd/json_output_empty.txt \
1287         test/data/bdev-rbd/json_output_extra_matches.txt \
1288         test/data/bdev-rbd/json_output_no_matches.txt \
1289         test/data/bdev-rbd/json_output_ok.txt \
1290         test/data/bdev-rbd/plain_output_new_extra_matches.txt \
1291         test/data/bdev-rbd/plain_output_new_no_matches.txt \
1292         test/data/bdev-rbd/plain_output_new_ok.txt \
1293         test/data/bdev-rbd/plain_output_old_empty.txt \
1294         test/data/bdev-rbd/plain_output_old_extra_matches.txt \
1295         test/data/bdev-rbd/plain_output_old_no_matches.txt \
1296         test/data/bdev-rbd/plain_output_old_ok.txt \
1297         test/data/bdev-rbd/output_invalid.txt \
1298         test/data/cert1.pem \
1299         test/data/cert2.pem \
1300         test/data/cluster_config_2.7.json \
1301         test/data/cluster_config_2.8.json \
1302         test/data/cluster_config_2.9.json \
1303         test/data/instance-minor-pairing.txt \
1304         test/data/instance-prim-sec.txt \
1305         test/data/ip-addr-show-dummy0.txt \
1306         test/data/ip-addr-show-lo-ipv4.txt \
1307         test/data/ip-addr-show-lo-ipv6.txt \
1308         test/data/ip-addr-show-lo-oneline-ipv4.txt \
1309         test/data/ip-addr-show-lo-oneline-ipv6.txt \
1310         test/data/ip-addr-show-lo-oneline.txt \
1311         test/data/ip-addr-show-lo.txt \
1312         test/data/kvm_0.12.5_help.txt \
1313         test/data/kvm_0.15.90_help.txt \
1314         test/data/kvm_0.9.1_help.txt \
1315         test/data/kvm_0.9.1_help_boot_test.txt \
1316         test/data/kvm_1.0_help.txt \
1317         test/data/kvm_1.1.2_help.txt \
1318         test/data/lvs_lv.txt \
1319         test/data/NEWS_OK.txt \
1320         test/data/NEWS_previous_unreleased.txt \
1321         test/data/ovfdata/compr_disk.vmdk.gz \
1322         test/data/ovfdata/config.ini \
1323         test/data/ovfdata/corrupted_resources.ovf \
1324         test/data/ovfdata/empty.ini \
1325         test/data/ovfdata/empty.ovf \
1326         test/data/ovfdata/ganeti.mf \
1327         test/data/ovfdata/ganeti.ovf \
1328         test/data/ovfdata/gzip_disk.ovf \
1329         test/data/ovfdata/new_disk.vmdk \
1330         test/data/ovfdata/no_disk.ini \
1331         test/data/ovfdata/no_disk_in_ref.ovf \
1332         test/data/ovfdata/no_os.ini \
1333         test/data/ovfdata/no_ovf.ova \
1334         test/data/ovfdata/other/rawdisk.raw \
1335         test/data/ovfdata/ova.ova \
1336         test/data/ovfdata/rawdisk.raw \
1337         test/data/ovfdata/second_disk.vmdk \
1338         test/data/ovfdata/unsafe_path.ini \
1339         test/data/ovfdata/virtualbox.ovf \
1340         test/data/ovfdata/wrong_config.ini \
1341         test/data/ovfdata/wrong_extension.ovd \
1342         test/data/ovfdata/wrong_manifest.mf \
1343         test/data/ovfdata/wrong_manifest.ovf \
1344         test/data/ovfdata/wrong_ova.ova \
1345         test/data/ovfdata/wrong_xml.ovf \
1346         test/data/proc_diskstats.txt \
1347         test/data/proc_drbd8.txt \
1348         test/data/proc_drbd80-emptyline.txt \
1349         test/data/proc_drbd80-emptyversion.txt \
1350         test/data/proc_drbd83.txt \
1351         test/data/proc_drbd83_sync.txt \
1352         test/data/proc_drbd83_sync_want.txt \
1353         test/data/proc_drbd83_sync_krnl2.6.39.txt \
1354         test/data/proc_drbd84.txt \
1355         test/data/proc_drbd84_sync.txt \
1356         test/data/proc_meminfo.txt \
1357         test/data/proc_cpuinfo.txt \
1358         test/data/qa-minimal-nodes-instances-only.json \
1359         test/data/sys_drbd_usermode_helper.txt \
1360         test/data/vgreduce-removemissing-2.02.02.txt \
1361         test/data/vgreduce-removemissing-2.02.66-fail.txt \
1362         test/data/vgreduce-removemissing-2.02.66-ok.txt \
1363         test/data/vgs-missing-pvs-2.02.02.txt \
1364         test/data/vgs-missing-pvs-2.02.66.txt \
1365         test/data/xen-xm-info-4.0.1.txt \
1366         test/data/xen-xm-list-4.0.1-dom0-only.txt \
1367         test/data/xen-xm-list-4.0.1-four-instances.txt \
1368         test/data/xen-xm-list-long-4.0.1.txt \
1369         test/data/xen-xm-uptime-4.0.1.txt \
1370         test/py/ganeti-cli.test \
1371         test/py/gnt-cli.test \
1372         test/py/import-export_unittest-helper
1373
1374
1375 python_tests = \
1376         doc/examples/rapi_testutils.py \
1377         test/py/cmdlib/cluster_unittest.py \
1378         test/py/cmdlib/cmdlib_unittest.py \
1379         test/py/cmdlib/group_unittest.py \
1380         test/py/cmdlib/instance_unittest.py \
1381         test/py/cmdlib/instance_migration_unittest.py \
1382         test/py/cmdlib/instance_query_unittest.py \
1383         test/py/cmdlib/instance_storage_unittest.py \
1384         test/py/cmdlib/node_unittest.py \
1385         test/py/cmdlib/test_unittest.py \
1386         test/py/cfgupgrade_unittest.py \
1387         test/py/docs_unittest.py \
1388         test/py/ganeti.asyncnotifier_unittest.py \
1389         test/py/ganeti.backend_unittest-runasroot.py \
1390         test/py/ganeti.backend_unittest.py \
1391         test/py/ganeti.bootstrap_unittest.py \
1392         test/py/ganeti.cli_unittest.py \
1393         test/py/ganeti.client.gnt_cluster_unittest.py \
1394         test/py/ganeti.client.gnt_instance_unittest.py \
1395         test/py/ganeti.client.gnt_job_unittest.py \
1396         test/py/ganeti.compat_unittest.py \
1397         test/py/ganeti.confd.client_unittest.py \
1398         test/py/ganeti.config_unittest.py \
1399         test/py/ganeti.constants_unittest.py \
1400         test/py/ganeti.daemon_unittest.py \
1401         test/py/ganeti.errors_unittest.py \
1402         test/py/ganeti.hooks_unittest.py \
1403         test/py/ganeti.ht_unittest.py \
1404         test/py/ganeti.http_unittest.py \
1405         test/py/ganeti.hypervisor.hv_chroot_unittest.py \
1406         test/py/ganeti.hypervisor.hv_fake_unittest.py \
1407         test/py/ganeti.hypervisor.hv_kvm_unittest.py \
1408         test/py/ganeti.hypervisor.hv_lxc_unittest.py \
1409         test/py/ganeti.hypervisor.hv_xen_unittest.py \
1410         test/py/ganeti.hypervisor_unittest.py \
1411         test/py/ganeti.impexpd_unittest.py \
1412         test/py/ganeti.jqueue_unittest.py \
1413         test/py/ganeti.jstore_unittest.py \
1414         test/py/ganeti.locking_unittest.py \
1415         test/py/ganeti.luxi_unittest.py \
1416         test/py/ganeti.masterd.iallocator_unittest.py \
1417         test/py/ganeti.masterd.instance_unittest.py \
1418         test/py/ganeti.mcpu_unittest.py \
1419         test/py/ganeti.netutils_unittest.py \
1420         test/py/ganeti.objects_unittest.py \
1421         test/py/ganeti.opcodes_unittest.py \
1422         test/py/ganeti.outils_unittest.py \
1423         test/py/ganeti.ovf_unittest.py \
1424         test/py/ganeti.qlang_unittest.py \
1425         test/py/ganeti.query_unittest.py \
1426         test/py/ganeti.rapi.baserlib_unittest.py \
1427         test/py/ganeti.rapi.client_unittest.py \
1428         test/py/ganeti.rapi.resources_unittest.py \
1429         test/py/ganeti.rapi.rlib2_unittest.py \
1430         test/py/ganeti.rapi.testutils_unittest.py \
1431         test/py/ganeti.rpc_unittest.py \
1432         test/py/ganeti.runtime_unittest.py \
1433         test/py/ganeti.serializer_unittest.py \
1434         test/py/ganeti.server.rapi_unittest.py \
1435         test/py/ganeti.ssconf_unittest.py \
1436         test/py/ganeti.ssh_unittest.py \
1437         test/py/ganeti.storage.bdev_unittest.py \
1438         test/py/ganeti.storage.container_unittest.py \
1439         test/py/ganeti.storage.drbd_unittest.py \
1440         test/py/ganeti.storage.filestorage_unittest.py \
1441         test/py/ganeti.tools.burnin_unittest.py \
1442         test/py/ganeti.tools.ensure_dirs_unittest.py \
1443         test/py/ganeti.tools.node_daemon_setup_unittest.py \
1444         test/py/ganeti.tools.prepare_node_join_unittest.py \
1445         test/py/ganeti.uidpool_unittest.py \
1446         test/py/ganeti.utils.algo_unittest.py \
1447         test/py/ganeti.utils.filelock_unittest.py \
1448         test/py/ganeti.utils.hash_unittest.py \
1449         test/py/ganeti.utils.io_unittest-runasroot.py \
1450         test/py/ganeti.utils.io_unittest.py \
1451         test/py/ganeti.utils.log_unittest.py \
1452         test/py/ganeti.utils.lvm_unittest.py \
1453         test/py/ganeti.utils.mlock_unittest.py \
1454         test/py/ganeti.utils.nodesetup_unittest.py \
1455         test/py/ganeti.utils.process_unittest.py \
1456         test/py/ganeti.utils.retry_unittest.py \
1457         test/py/ganeti.utils.storage_unittest.py \
1458         test/py/ganeti.utils.text_unittest.py \
1459         test/py/ganeti.utils.version_unittest.py \
1460         test/py/ganeti.utils.wrapper_unittest.py \
1461         test/py/ganeti.utils.x509_unittest.py \
1462         test/py/ganeti.utils_unittest.py \
1463         test/py/ganeti.vcluster_unittest.py \
1464         test/py/ganeti.workerpool_unittest.py \
1465         test/py/pycurl_reset_unittest.py \
1466         test/py/qa.qa_config_unittest.py \
1467         test/py/tempfile_fork_unittest.py
1468
1469 python_test_support = \
1470         test/py/__init__.py \
1471         test/py/lockperf.py \
1472         test/py/testutils.py \
1473         test/py/mocks.py \
1474         test/py/cmdlib/__init__.py \
1475         test/py/cmdlib/testsupport/__init__.py \
1476         test/py/cmdlib/testsupport/cmdlib_testcase.py \
1477         test/py/cmdlib/testsupport/config_mock.py \
1478         test/py/cmdlib/testsupport/iallocator_mock.py \
1479         test/py/cmdlib/testsupport/lock_manager_mock.py \
1480         test/py/cmdlib/testsupport/netutils_mock.py \
1481         test/py/cmdlib/testsupport/processor_mock.py \
1482         test/py/cmdlib/testsupport/rpc_runner_mock.py \
1483         test/py/cmdlib/testsupport/ssh_mock.py \
1484         test/py/cmdlib/testsupport/util.py
1485
1486 haskell_tests = test/hs/htest
1487
1488 dist_TESTS = \
1489         test/py/check-cert-expired_unittest.bash \
1490         test/py/daemon-util_unittest.bash \
1491         test/py/ganeti-cleaner_unittest.bash \
1492         test/py/import-export_unittest.bash \
1493         test/py/cli-test.bash \
1494         test/py/bash_completion.bash
1495
1496 if PY_UNIT
1497 dist_TESTS += $(python_tests)
1498 endif
1499
1500 nodist_TESTS =
1501 check_SCRIPTS =
1502
1503 if WANT_HSTESTS
1504 nodist_TESTS += $(haskell_tests)
1505 dist_TESTS += test/hs/offline-test.sh
1506 check_SCRIPTS += \
1507         test/hs/hpc-htools \
1508         test/hs/hpc-mon-collector \
1509         $(HS_BUILT_TEST_HELPERS)
1510 endif
1511
1512 TESTS = $(dist_TESTS) $(nodist_TESTS)
1513
1514 # Environment for all tests
1515 PLAIN_TESTS_ENVIRONMENT = \
1516         PYTHONPATH=.:./test/py \
1517         TOP_SRCDIR=$(abs_top_srcdir) TOP_BUILDDIR=$(abs_top_builddir) \
1518         PYTHON=$(PYTHON) FAKEROOT=$(FAKEROOT_PATH) \
1519         $(RUN_IN_TEMPDIR)
1520
1521 # Environment for tests run by automake
1522 TESTS_ENVIRONMENT = \
1523         $(PLAIN_TESTS_ENVIRONMENT) $(abs_top_srcdir)/autotools/testrunner
1524
1525 all_python_code = \
1526         $(dist_sbin_SCRIPTS) \
1527         $(python_scripts) \
1528         $(pkglib_python_scripts) \
1529         $(nodist_pkglib_python_scripts) \
1530         $(nodist_tools_python_scripts) \
1531         $(pkgpython_PYTHON) \
1532         $(client_PYTHON) \
1533         $(cmdlib_PYTHON) \
1534         $(hypervisor_PYTHON) \
1535         $(storage_PYTHON) \
1536         $(rapi_PYTHON) \
1537         $(server_PYTHON) \
1538         $(pytools_PYTHON) \
1539         $(http_PYTHON) \
1540         $(confd_PYTHON) \
1541         $(masterd_PYTHON) \
1542         $(impexpd_PYTHON) \
1543         $(utils_PYTHON) \
1544         $(watcher_PYTHON) \
1545         $(noinst_PYTHON) \
1546         $(qa_scripts)
1547
1548 if PY_UNIT
1549 all_python_code += $(python_tests)
1550 all_python_code += $(python_test_support)
1551 endif
1552
1553 srclink_files = \
1554         man/footer.rst \
1555         test/py/check-cert-expired_unittest.bash \
1556         test/py/daemon-util_unittest.bash \
1557         test/py/ganeti-cleaner_unittest.bash \
1558         test/py/import-export_unittest.bash \
1559         test/py/cli-test.bash \
1560         test/py/bash_completion.bash \
1561         test/hs/offline-test.sh \
1562         test/hs/cli-tests-defs.sh \
1563         $(all_python_code) \
1564         $(HS_LIBTEST_SRCS) $(HS_PROG_SRCS) \
1565         $(docinput)
1566
1567 check_python_code = \
1568         $(BUILD_BASH_COMPLETION) \
1569         $(CHECK_IMPORTS) \
1570         $(CHECK_HEADER) \
1571         $(DOCPP) \
1572         $(all_python_code)
1573
1574 lint_python_code = \
1575         ganeti \
1576         ganeti/http/server.py \
1577         $(dist_sbin_SCRIPTS) \
1578         $(python_scripts) \
1579         $(pkglib_python_scripts) \
1580         $(BUILD_BASH_COMPLETION) \
1581         $(CHECK_IMPORTS) \
1582         $(CHECK_HEADER) \
1583         $(DOCPP) \
1584         $(gnt_python_sbin_SCRIPTS) \
1585         $(PYTHON_BOOTSTRAP)
1586
1587 standalone_python_modules = \
1588         lib/rapi/client.py \
1589         tools/ganeti-listrunner
1590
1591 pep8_python_code = \
1592         ganeti \
1593         ganeti/http/server.py \
1594         $(dist_sbin_SCRIPTS) \
1595         $(python_scripts) \
1596         $(pkglib_python_scripts) \
1597         $(BUILD_BASH_COMPLETION) \
1598         $(CHECK_HEADER) \
1599         $(DOCPP) \
1600         $(PYTHON_BOOTSTRAP) \
1601         $(gnt_python_sbin_SCRIPTS) \
1602         qa \
1603         $(python_test_support)
1604
1605 test/py/daemon-util_unittest.bash: daemons/daemon-util
1606
1607 test/py/ganeti-cleaner_unittest.bash: daemons/ganeti-cleaner
1608
1609 test/py/bash_completion.bash: doc/examples/bash_completion-debug
1610
1611 tools/kvm-ifup: tools/kvm-ifup.in $(REPLACE_VARS_SED)
1612         sed -f $(REPLACE_VARS_SED) < $< > $@
1613         chmod +x $@
1614
1615 tools/vif-ganeti: tools/vif-ganeti.in $(REPLACE_VARS_SED)
1616         sed -f $(REPLACE_VARS_SED) < $< > $@
1617         chmod +x $@
1618
1619 tools/net-common: tools/net-common.in $(REPLACE_VARS_SED)
1620         sed -f $(REPLACE_VARS_SED) < $< > $@
1621         chmod +x $@
1622
1623 tools/users-setup: Makefile $(userspecs)
1624         set -e; \
1625         { echo '#!/bin/sh'; \
1626           echo 'if [ "x$$1" != "x--yes-do-it" ];'; \
1627           echo 'then echo "This will do the following changes"'; \
1628           $(AWK) -- '{print "echo + Will add group ",$$1; count++}\
1629                      END {if (count == 0) {print "echo + No groups to add"}}' doc/users/groups; \
1630           $(AWK) -- '{if (NF > 1) {print "echo + Will add user",$$1,"with primary group",$$2} \
1631                                   else {print "echo + Will add user",$$1}; count++}\
1632                      END {if (count == 0) {print "echo + No users to add"}}' doc/users/users; \
1633           $(AWK) -- '{print "echo + Will add user",$$1,"to group",$$2}' doc/users/groupmemberships; \
1634           echo 'echo'; \
1635           echo 'echo "OK? (y/n)"'; \
1636           echo 'read confirm'; \
1637           echo 'if [ "x$$confirm" != "xy" ]; then exit 0; fi'; \
1638           echo 'fi'; \
1639           $(AWK) -- '{print "addgroup --system",$$1}' doc/users/groups; \
1640           $(AWK) -- '{if (NF > 1) {print "adduser --system --ingroup",$$2,$$1} else {print "adduser --system",$$1}}' doc/users/users; \
1641           $(AWK) -- '{print "adduser",$$1,$$2}' doc/users/groupmemberships; \
1642         } > $@
1643         chmod +x $@
1644
1645 tools/vcluster-setup: tools/vcluster-setup.in $(REPLACE_VARS_SED)
1646         sed -f $(REPLACE_VARS_SED) < $< > $@
1647         chmod +x $@
1648
1649 daemons/%:: daemons/%.in $(REPLACE_VARS_SED)
1650         sed -f $(REPLACE_VARS_SED) < $< > $@
1651         chmod +x $@
1652
1653 doc/examples/%:: doc/examples/%.in $(REPLACE_VARS_SED)
1654         sed -f $(REPLACE_VARS_SED) < $< > $@
1655
1656 doc/examples/bash_completion: BC_ARGS = --compact
1657 doc/examples/bash_completion-debug: BC_ARGS =
1658
1659 doc/examples/bash_completion doc/examples/bash_completion-debug: \
1660         $(BUILD_BASH_COMPLETION) $(RUN_IN_TEMPDIR) \
1661         lib/cli.py $(gnt_scripts) $(client_PYTHON) tools/burnin \
1662         daemons/ganeti-cleaner \
1663         $(GENERATED_FILES) $(HS_GENERATED_FILES)
1664         PYTHONPATH=. $(RUN_IN_TEMPDIR) \
1665           $(CURDIR)/$(BUILD_BASH_COMPLETION) $(BC_ARGS) > $@
1666
1667 man/%.gen: man/%.rst lib/query.py lib/build/sphinx_ext.py \
1668         lib/build/shell_example_lexer.py \
1669         | $(RUN_IN_TEMPDIR) $(BUILT_PYTHON_SOURCES)
1670         @echo "Checking $< for hardcoded paths..."
1671         @if grep -nEf autotools/wrong-hardcoded-paths $<; then \
1672           echo "Man page $< has hardcoded paths (see above)!" 1>&2 ; \
1673           exit 1; \
1674         fi
1675         set -e ; \
1676         trap 'echo auto-removing $@; rm $@' EXIT; \
1677         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(DOCPP) < $< > $@ ;\
1678         $(CHECK_MAN_REFERENCES) $@; \
1679         trap - EXIT
1680
1681 man/%.7.in man/%.8.in man/%.1.in: man/%.gen man/footer.rst
1682         @test -n "$(PANDOC)" || \
1683           { echo 'pandoc' not found during configure; exit 1; }
1684         set -o pipefail -e; \
1685         trap 'echo auto-removing $@; rm $@' EXIT; \
1686         $(PANDOC) -s -f rst -t man $< man/footer.rst | \
1687           sed -e 's/\\@/@/g' > $@; \
1688         if test -n "$(MAN_HAS_WARNINGS)"; then $(CHECK_MAN_WARNINGS) $@; fi; \
1689         $(CHECK_MAN_DASHES) $@; \
1690         trap - EXIT
1691
1692 man/%.html.in: man/%.gen man/footer.rst
1693         @test -n "$(PANDOC)" || \
1694           { echo 'pandoc' not found during configure; exit 1; }
1695         set -o pipefail ; \
1696         $(PANDOC) --toc -s -f rst -t html $< man/footer.rst | \
1697           sed -e 's/\\@/@/g' > $@
1698
1699 man/%: man/%.in  $(REPLACE_VARS_SED)
1700         sed -f $(REPLACE_VARS_SED) < $< > $@
1701
1702 epydoc.conf: epydoc.conf.in $(REPLACE_VARS_SED)
1703         sed -f $(REPLACE_VARS_SED) < $< > $@
1704
1705 vcs-version:
1706         if test -d .git; then \
1707           git describe > $@; \
1708         elif test ! -f $@ ; then \
1709           echo "Cannot auto-generate $@ file"; exit 1; \
1710         fi
1711
1712 .PHONY: clean-vcs-version
1713 clean-vcs-version:
1714         rm -f vcs-version
1715
1716 .PHONY: regen-vcs-version
1717 regen-vcs-version:
1718         @set -e; \
1719         cd $(srcdir); \
1720         if test -d .git; then \
1721           T=`mktemp` ; trap 'rm -f $$T' EXIT; \
1722           git describe > $$T; \
1723           if ! cmp --quiet $$T vcs-version; then \
1724             mv $$T vcs-version; \
1725           fi; \
1726         fi
1727
1728 src/Ganeti/Version.hs: src/Ganeti/Version.hs.in \
1729         vcs-version $(built_base_sources)
1730         set -e; \
1731         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
1732         sed -e "s/%ver%/$$VCSVER/" < $< > $@
1733
1734 src/Ganeti/Hs2Py/ListConstants.hs: src/Ganeti/Hs2Py/ListConstants.hs.in \
1735                                    src/Ganeti/HsConstants.hs \
1736                                  | stamp-directories
1737         @echo Generating $@
1738         @set -e; \
1739 ## Extract constant names from 'HsConstants.hs' by extracting the left
1740 ## side of all lines containing an equal sign (i.e., '=') and
1741 ## prepending the apostrophe sign (i.e., "'").
1742 ##
1743 ## For example, the constant
1744 ##   adminstDown = ...
1745 ## becomes
1746 ##   'adminstDown
1747         NAMES=$$(sed -n -e "/=/ s/\(.*\) =.*/    '\1:/g p" \
1748                  $(abs_top_srcdir)/src/Ganeti/HsConstants.hs); \
1749         m4 -DPY_CONSTANT_NAMES="$$NAMES" $(abs_top_srcdir)/$< > $@
1750
1751 src/Ganeti/PyConstants.hs: src/Ganeti/PyConstants.hs.in \
1752         lib/constants.py lib/luxi.py lib/errors.py \
1753         lib/jstore.py $(RUN_IN_TEMPDIR) \
1754         $(CONVERT_CONSTANTS) $(built_base_sources) \
1755         | lib/_vcsversion.py
1756         set -e; \
1757         { cat $< ; \
1758           PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(CONVERT_CONSTANTS); \
1759         } > $@
1760
1761 src/Ganeti/Curl/Internal.hs: src/Ganeti/Curl/Internal.hsc | stamp-directories
1762         hsc2hs -o $@ $<
1763
1764 test/hs/Test/Ganeti/TestImports.hs: test/hs/Test/Ganeti/TestImports.hs.in \
1765         $(built_base_sources)
1766         set -e; \
1767         { cat $< ; \
1768           echo ; \
1769           for name in $(filter-out Ganeti.THH,$(subst /,.,$(patsubst %.hs,%,$(patsubst src/%,%,$(HS_LIB_SRCS))))) ; do \
1770             echo "import $$name ()" ; \
1771           done ; \
1772         } > $@
1773
1774 lib/_constants.py: Makefile lib/_constants.py.in src/hs2py-constants \
1775                  | stamp-directories
1776         cat $(abs_top_srcdir)/lib/_constants.py.in > $@
1777         src/hs2py-constants >> $@
1778
1779 lib/constants.py: lib/_constants.py
1780
1781 src/AutoConf.hs: Makefile src/AutoConf.hs.in | stamp-directories
1782         @echo "m4 ... >" $@
1783         @m4 -DPACKAGE_VERSION="$(PACKAGE_VERSION)" \
1784             -DVERSION_MAJOR="$(VERSION_MAJOR)" \
1785             -DVERSION_MINOR="$(VERSION_MINOR)" \
1786             -DVERSION_REVISION="$(VERSION_REVISION)" \
1787             -DVERSION_SUFFIX="$(VERSION_SUFFIX)" \
1788             -DVERSION_FULL="$(VERSION_FULL)" \
1789             -DLOCALSTATEDIR="$(localstatedir)" \
1790             -DSYSCONFDIR="$(sysconfdir)" \
1791             -DSSH_CONFIG_DIR="$(SSH_CONFIG_DIR)" \
1792             -DSSH_LOGIN_USER="$(SSH_LOGIN_USER)" \
1793             -DSSH_CONSOLE_USER="$(SSH_CONSOLE_USER)" \
1794             -DEXPORT_DIR="$(EXPORT_DIR)" \
1795             -DOS_SEARCH_PATH="$(foreach i,$(OS_SEARCH_PATH),\"$(i)\":)" \
1796             -DES_SEARCH_PATH="$(foreach i,$(ES_SEARCH_PATH),\"$(i)\":)" \
1797             -DXEN_BOOTLOADER="$(XEN_BOOTLOADER)" \
1798             -DXEN_CONFIG_DIR="$(XEN_CONFIG_DIR)" \
1799             -DXEN_KERNEL="$(XEN_KERNEL)" \
1800             -DXEN_INITRD="$(XEN_INITRD)" \
1801             -DKVM_KERNEL="$(KVM_KERNEL)" \
1802             -DSHARED_FILE_STORAGE_DIR="$(SHARED_FILE_STORAGE_DIR)" \
1803             -DIALLOCATOR_SEARCH_PATH="$(foreach i,$(IALLOCATOR_SEARCH_PATH),\"$(i)\":)" \
1804             -DKVM_PATH="$(KVM_PATH)" \
1805             -DIP_PATH="$(IP_PATH)" \
1806             -DSOCAT_PATH="$(SOCAT)" \
1807             -DSOCAT_USE_ESCAPE="$(SOCAT_USE_ESCAPE)" \
1808             -DSOCAT_USE_COMPRESS="$(SOCAT_USE_COMPRESS)" \
1809             -DLVM_STRIPECOUNT="$(LVM_STRIPECOUNT)" \
1810             -DTOOLSDIR="$(libdir)/ganeti/tools" \
1811             -DGNT_SCRIPTS="$(foreach i,$(notdir $(gnt_scripts)),\"$(i)\":)" \
1812             -DHS_HTOOLS_PROGS="$(foreach i,$(HS_HTOOLS_PROGS),\"$(i)\":)" \
1813             -DPKGLIBDIR="$(libdir)/ganeti" \
1814             -DVERSIONEDSHAREDIR="$(versionedsharedir)" \
1815             -DDRBD_BARRIERS="$(DRBD_BARRIERS)" \
1816             -DDRBD_NO_META_FLUSH="$(DRBD_NO_META_FLUSH)" \
1817             -DSYSLOG_USAGE="$(SYSLOG_USAGE)" \
1818             -DDAEMONS_GROUP="$(DAEMONS_GROUP)" \
1819             -DADMIN_GROUP="$(ADMIN_GROUP)" \
1820             -DMASTERD_USER="$(MASTERD_USER)" \
1821             -DMASTERD_GROUP="$(MASTERD_GROUP)" \
1822             -DRAPI_USER="$(RAPI_USER)" \
1823             -DRAPI_GROUP="$(RAPI_GROUP)" \
1824             -DCONFD_USER="$(CONFD_USER)" \
1825             -DCONFD_GROUP="$(CONFD_GROUP)" \
1826             -DLUXID_USER="$(LUXID_USER)" \
1827             -DLUXID_GROUP="$(LUXID_GROUP)" \
1828             -DNODED_USER="$(NODED_USER)" \
1829             -DNODED_GROUP="$(NODED_GROUP)" \
1830             -DMOND_USER="$(MOND_USER)" \
1831             -DMOND_GROUP="$(MOND_GROUP)" \
1832             -DDISK_SEPARATOR="$(DISK_SEPARATOR)" \
1833             -DQEMUIMG_PATH="$(QEMUIMG_PATH)" \
1834             -DHTOOLS="True" \
1835             -DENABLE_CONFD="$(ENABLE_CONFD)" \
1836             -DXEN_CMD="$(XEN_CMD)" \
1837             -DENABLE_SPLIT_QUERY="$(ENABLE_SPLIT_QUERY)" \
1838             -DENABLE_RESTRICTED_COMMANDS="$(ENABLE_RESTRICTED_COMMANDS)" \
1839             -DENABLE_MOND="$(ENABLE_MOND)" \
1840             -DMAN_PAGES="$$(for i in $(notdir $(man_MANS)); do \
1841                             echo -n "$$i" | sed -re 's/^(.*)\.([0-9]+)$$/("\1",\2):/g'; \
1842                             done)" \
1843         $(abs_top_srcdir)/src/AutoConf.hs.in > $@
1844
1845 lib/_vcsversion.py: Makefile vcs-version | stamp-directories
1846         set -e; \
1847         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
1848         { echo '# This file is automatically generated, do not edit!'; \
1849           echo '#'; \
1850           echo ''; \
1851           echo '"""Build-time VCS version number for Ganeti.'; \
1852           echo '';\
1853           echo 'This file is autogenerated by the build process.'; \
1854           echo 'For any changes you need to re-run ./configure (and'; \
1855           echo 'not edit by hand).'; \
1856           echo ''; \
1857           echo '"""'; \
1858           echo ''; \
1859           echo '# pylint: disable=C0301,C0324'; \
1860           echo '# because this is autogenerated, we do not want'; \
1861           echo '# style warnings' ; \
1862           echo ''; \
1863           echo "VCS_VERSION = '$$VCSVER'"; \
1864         } > $@
1865
1866 lib/opcodes.py: Makefile src/hs2py src/Ganeti/PyConstants.hs \
1867                 lib/opcodes.py.in_before lib/opcodes.py.in_after \
1868                 | stamp-directories
1869         cat $(abs_top_srcdir)/lib/opcodes.py.in_before > $@
1870         src/hs2py >> $@
1871         cat $(abs_top_srcdir)/lib/opcodes.py.in_after >> $@
1872
1873 lib/_generated_rpc.py: lib/rpc_defs.py $(BUILD_RPC)
1874         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(BUILD_RPC) lib/rpc_defs.py > $@
1875
1876 $(SHELL_ENV_INIT): Makefile stamp-directories
1877         set -e; \
1878         { echo '# Allow overriding for tests'; \
1879           echo 'readonly LOCALSTATEDIR=$${LOCALSTATEDIR:-$${GANETI_ROOTDIR:-}$(localstatedir)}'; \
1880           echo 'readonly SYSCONFDIR=$${SYSCONFDIR:-$${GANETI_ROOTDIR:-}$(sysconfdir)}'; \
1881           echo; \
1882           echo 'readonly PKGLIBDIR=$(libdir)/ganeti'; \
1883           echo 'readonly LOG_DIR="$$LOCALSTATEDIR/log/ganeti"'; \
1884           echo 'readonly RUN_DIR="$$LOCALSTATEDIR/run/ganeti"'; \
1885           echo 'readonly DATA_DIR="$$LOCALSTATEDIR/lib/ganeti"'; \
1886           echo 'readonly CONF_DIR="$$SYSCONFDIR/ganeti"'; \
1887         } > $@
1888
1889 ## Writes sed script to replace placeholders with build-time values. The
1890 ## additional quotes after the first @ sign are necessary to stop configure
1891 ## from replacing those values as well.
1892 $(REPLACE_VARS_SED): $(SHELL_ENV_INIT) Makefile stamp-directories
1893         set -e; \
1894         { echo 's#@''PREFIX@#$(prefix)#g'; \
1895           echo 's#@''SYSCONFDIR@#$(sysconfdir)#g'; \
1896           echo 's#@''LOCALSTATEDIR@#$(localstatedir)#g'; \
1897           echo 's#@''BINDIR@#$(execprefix)/bin#g'; \
1898           echo 's#@''SBINDIR@#$(execprefix)/sbin#g'; \
1899           echo 's#@''LIBDIR@#$(libdir)#g'; \
1900           echo 's#@''GANETI_VERSION@#$(PACKAGE_VERSION)#g'; \
1901           echo 's#@''CUSTOM_XEN_BOOTLOADER@#$(XEN_BOOTLOADER)#g'; \
1902           echo 's#@''CUSTOM_XEN_KERNEL@#$(XEN_KERNEL)#g'; \
1903           echo 's#@''CUSTOM_XEN_INITRD@#$(XEN_INITRD)#g'; \
1904           echo 's#@''CUSTOM_IALLOCATOR_SEARCH_PATH@#$(IALLOCATOR_SEARCH_PATH)#g'; \
1905           echo 's#@''CUSTOM_EXPORT_DIR@#$(EXPORT_DIR)#g'; \
1906           echo 's#@''RPL_SSH_INITD_SCRIPT@#$(SSH_INITD_SCRIPT)#g'; \
1907           echo 's#@''PKGLIBDIR@#$(libdir)/ganeti#g'; \
1908           echo 's#@''GNTMASTERUSER@#$(MASTERD_USER)#g'; \
1909           echo 's#@''GNTRAPIUSER@#$(RAPI_USER)#g'; \
1910           echo 's#@''GNTCONFDUSER@#$(CONFD_USER)#g'; \
1911           echo 's#@''GNTLUXIDUSER@#$(LUXID_USER)#g'; \
1912           echo 's#@''GNTNODEDUSER@#$(NODED_USER)#g'; \
1913           echo 's#@''GNTMONDUSER@#$(MOND_USER)#g'; \
1914           echo 's#@''GNTRAPIGROUP@#$(RAPI_GROUP)#g'; \
1915           echo 's#@''GNTADMINGROUP@#$(ADMIN_GROUP)#g'; \
1916           echo 's#@''GNTCONFDGROUP@#$(CONFD_GROUP)#g'; \
1917           echo 's#@''GNTLUXIDGROUP@#$(LUXID_GROUP)#g'; \
1918           echo 's#@''GNTMASTERDGROUP@#$(MASTERD_GROUP)#g'; \
1919           echo 's#@''GNTMONDGROUP@#$(MOND_GROUP)#g'; \
1920           echo 's#@''GNTDAEMONSGROUP@#$(DAEMONS_GROUP)#g'; \
1921           echo 's#@''CUSTOM_ENABLE_CONFD@#$(ENABLE_CONFD)#g'; \
1922           echo 's#@''CUSTOM_ENABLE_MOND@#$(ENABLE_MOND)#g'; \
1923           echo 's#@''MODULES@#$(strip $(lint_python_code))#g'; \
1924           echo 's#@''XEN_CONFIG_DIR@#$(XEN_CONFIG_DIR)#g'; \
1925           echo; \
1926           echo '/^@SHELL_ENV_INIT@$$/ {'; \
1927           echo '  r $(SHELL_ENV_INIT)'; \
1928           echo '  d'; \
1929           echo '}'; \
1930         } > $@
1931
1932 # Using deferred evaluation
1933 daemons/ganeti-%: MODULE = ganeti.server.$(patsubst ganeti-%,%,$(notdir $@))
1934 daemons/ganeti-watcher: MODULE = ganeti.watcher
1935 scripts/%: MODULE = ganeti.client.$(subst -,_,$(notdir $@))
1936 tools/burnin: MODULE = ganeti.tools.burnin
1937 tools/ensure-dirs: MODULE = ganeti.tools.ensure_dirs
1938 tools/node-daemon-setup: MODULE = ganeti.tools.node_daemon_setup
1939 tools/prepare-node-join: MODULE = ganeti.tools.prepare_node_join
1940 tools/node-cleanup: MODULE = ganeti.tools.node_cleanup
1941 $(HS_BUILT_TEST_HELPERS): TESTROLE = $(patsubst test/hs/%,%,$@)
1942
1943 $(PYTHON_BOOTSTRAP) $(gnt_scripts) $(gnt_python_sbin_SCRIPTS): Makefile | stamp-directories
1944         test -n "$(MODULE)" || { echo Missing module; exit 1; }
1945         set -e; \
1946         { echo '#!/usr/bin/python'; \
1947           echo '# This file is automatically generated, do not edit!'; \
1948           echo "# Edit $(MODULE) instead."; \
1949           echo; \
1950           echo '"""Bootstrap script for L{$(MODULE)}"""'; \
1951           echo; \
1952           echo '# pylint: disable=C0103'; \
1953           echo '# C0103: Invalid name'; \
1954           echo; \
1955           echo 'import sys'; \
1956           echo 'import $(MODULE) as main'; \
1957           echo; \
1958           echo '# Temporarily alias commands until bash completion'; \
1959           echo '# generator is changed'; \
1960           echo 'if hasattr(main, "commands"):'; \
1961           echo '  commands = main.commands # pylint: disable=E1101'; \
1962           echo 'if hasattr(main, "aliases"):'; \
1963           echo '  aliases = main.aliases # pylint: disable=E1101'; \
1964           echo; \
1965           echo 'if __name__ == "__main__":'; \
1966           echo '  sys.exit(main.Main())'; \
1967         } > $@
1968         chmod u+x $@
1969
1970 $(HS_BUILT_TEST_HELPERS): Makefile
1971         @test -n "$(TESTROLE)" || { echo Missing TESTROLE; exit 1; }
1972         set -e; \
1973         { echo '#!/bin/sh'; \
1974           echo '# This file is automatically generated, do not edit!'; \
1975           echo "# Edit Makefile.am instead."; \
1976           echo; \
1977           echo "HTOOLS=$(TESTROLE) exec ./test/hs/hpc-htools \"\$$@\""; \
1978         } > $@
1979         chmod u+x $@
1980
1981 stamp-directories: Makefile
1982         $(MAKE) $(AM_MAKEFLAGS) ganeti
1983         @mkdir_p@ $(DIRS) $(BUILDTIME_DIR_AUTOCREATE)
1984         touch $@
1985
1986 # We need to create symlinks because "make distcheck" will not install Python
1987 # files when building.
1988 stamp-srclinks: Makefile | stamp-directories
1989         set -e; \
1990         for i in $(srclink_files); do \
1991           if test ! -f $$i -a -f $(abs_top_srcdir)/$$i; then \
1992             $(LN_S) $(abs_top_srcdir)/$$i $$i; \
1993           fi; \
1994         done
1995         touch $@
1996
1997 .PHONY: ganeti
1998 ganeti:
1999         cd $(top_builddir) && test -h "$@" || { rm -f $@ && $(LN_S) lib $@; }
2000
2001 .PHONY: check-dirs
2002 check-dirs: $(GENERATED_FILES)
2003         @set -e; \
2004         find . -type d \( -name . -o -name .git -prune -o -print \) | { \
2005           error=; \
2006           while read dir; do \
2007             case "$$dir" in \
2008               $(strip $(patsubst %,(./%) ;;,$(DIRCHECK_EXCLUDE) $(DIRS))) \
2009               *) error=1; echo "Directory $$dir not listed in Makefile" >&2 ;; \
2010             esac; \
2011           done; \
2012           for dir in $(DIRS); do \
2013             if ! test -d "$$dir"; then \
2014               echo "Directory $$dir listed in DIRS does not exist" >&2; \
2015               error=1; \
2016             fi \
2017           done; \
2018           test -z "$$error"; \
2019         }
2020
2021 .PHONY: check-local
2022 check-local: check-dirs $(GENERATED_FILES)
2023         $(CHECK_PYTHON_CODE) $(check_python_code)
2024         PYTHONPATH=. $(CHECK_HEADER) $(check_python_code)
2025         $(CHECK_VERSION) $(VERSION) $(top_srcdir)/NEWS
2026         RELEASE=$(PACKAGE_VERSION) $(CHECK_NEWS) < $(top_srcdir)/NEWS
2027         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(CHECK_IMPORTS) . $(standalone_python_modules)
2028         error= ; \
2029         if [ "x`echo $(VERSION_SUFFIX)|grep 'alpha'`" == "x" ]; then \
2030           expver=$(VERSION_MAJOR).$(VERSION_MINOR); \
2031           if test "`head -n 1 $(top_srcdir)/README`" != "Ganeti $$expver"; then \
2032             echo "Incorrect version in README, expected $$expver" >&2; \
2033             error=1; \
2034           fi; \
2035           for file in doc/iallocator.rst doc/hooks.rst doc/virtual-cluster.rst \
2036               doc/security.rst; do \
2037             if test "`sed -ne '4 p' $(top_srcdir)/$$file`" != \
2038               "Documents Ganeti version $$expver"; then \
2039               echo "Incorrect version in $$file, expected $$expver" >&2; \
2040               error=1; \
2041             fi; \
2042           done; \
2043           if ! test -f $(top_srcdir)/doc/design-$$expver.rst; then \
2044             echo "File $(top_srcdir)/doc/design-$$expver.rst not found" >&2; \
2045             error=1; \
2046           fi; \
2047           if test "`sed -ne '5 p' $(top_srcdir)/doc/design-draft.rst`" != \
2048             ".. Last updated for Ganeti $$expver"; then \
2049             echo "doc/design-draft.rst was not updated for version $$expver" >&2; \
2050             error=1; \
2051           fi; \
2052         fi; \
2053         for file in configure.ac $(HS_LIBTEST_SRCS) $(HS_PROG_SRCS); do \
2054           if test $$(wc --max-line-length < $(top_srcdir)/$$file) -gt 80; then \
2055             echo "Longest line in $$file is longer than 80 characters" >&2; \
2056             error=1; \
2057           fi; \
2058         done; \
2059         test -z "$$error"
2060
2061 .PHONY: hs-test-%
2062 hs-test-%: test/hs/htest | $(BUILT_PYTHON_SOURCES)
2063         @rm -f htest.tix
2064         test/hs/htest -t $*
2065
2066 .PHONY: hs-tests
2067 hs-tests: test/hs/htest | $(BUILT_PYTHON_SOURCES)
2068         @rm -f htest.tix
2069         ./test/hs/htest
2070
2071 .PHONY: hs-shell-%
2072 hs-shell-%: test/hs/hpc-htools test/hs/hpc-mon-collector \
2073             $(HS_BUILT_TEST_HELPERS)
2074         @rm -f hpc-htools.tix hpc-mon-collector.tix
2075         HBINARY="./test/hs/hpc-htools" \
2076         SHELLTESTARGS=$(SHELLTESTARGS) \
2077         ./test/hs/offline-test.sh $*
2078
2079 .PHONY: hs-shell
2080 hs-shell: test/hs/hpc-htools test/hs/hpc-mon-collector $(HS_BUILT_TEST_HELPERS)
2081         @rm -f hpc-htools.tix hpc-mon-collector.tix
2082         HBINARY="./test/hs/hpc-htools" \
2083         SHELLTESTARGS=$(SHELLTESTARGS) \
2084         ./test/hs/offline-test.sh
2085
2086 .PHONY: hs-check
2087 hs-check: hs-tests hs-shell
2088
2089 # E111: indentation is not a multiple of four
2090 # E121: continuation line indentation is not a multiple of four
2091 #       (since our indent level is not 4)
2092 # E125: continuation line does not distinguish itself from next logical line
2093 #       (since our indent level is not 4)
2094 # E123: closing bracket does not match indentation of opening bracket's line
2095 # E127: continuation line over-indented for visual indent
2096 #       (since our indent level is not 4)
2097 # note: do NOT add E128 here; it's a valid style error in most cases!
2098 # I've seen real errors, but also some cases were we indent wrongly
2099 # due to line length; try to rework the cases where it is triggered,
2100 # instead of silencing it
2101 # E261: at least two spaces before inline comment
2102 # E501: line too long (80 characters)
2103 PEP8_IGNORE = E111,E121,E123,E125,E127,E261,E501
2104
2105 # For excluding pep8 expects filenames only, not whole paths
2106 PEP8_EXCLUDE = $(subst $(space),$(comma),$(strip $(notdir $(BUILT_PYTHON_SOURCES))))
2107
2108 LINT_TARGETS = pylint pylint-qa pylint-test
2109 if HAS_PEP8
2110 LINT_TARGETS += pep8
2111 endif
2112 if HAS_HLINT
2113 LINT_TARGETS += hlint
2114 endif
2115
2116 .PHONY: lint
2117 lint: $(LINT_TARGETS)
2118
2119 .PHONY: pylint
2120 pylint: $(GENERATED_FILES)
2121         @test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
2122         $(PYLINT) $(LINT_OPTS) $(lint_python_code)
2123
2124 .PHONY: pylint-qa
2125 pylint-qa: $(GENERATED_FILES)
2126         @test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
2127         cd $(top_srcdir)/qa && \
2128           PYTHONPATH=$(abs_top_srcdir) $(PYLINT) $(LINT_OPTS) \
2129           --rcfile  ../pylintrc $(patsubst qa/%.py,%,$(qa_scripts))
2130 # FIXME: lint all test code, not just the newly added test support
2131 pylint-test: $(GENERATED_FILES)
2132         @test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
2133         cd $(top_srcdir) && \
2134                 PYTHONPATH=.:./test/py $(PYLINT) $(LINT_OPTS) \
2135                 --rcfile=pylintrc-test  $(python_test_support)
2136
2137 .PHONY: pep8
2138 pep8: $(GENERATED_FILES)
2139         @test -n "$(PEP8)" || { echo 'pep8' not found during configure; exit 1; }
2140         $(PEP8) --ignore='$(PEP8_IGNORE)' --exclude='$(PEP8_EXCLUDE)' \
2141           --repeat $(pep8_python_code)
2142
2143 # FIXME: remove ignore "Use void" when GHC 6.x is deprecated
2144 HLINT_EXCLUDES = src/Ganeti/THH.hs test/hs/hpc-htools.hs
2145 .PHONY: hlint
2146 hlint: $(HS_BUILT_SRCS) src/lint-hints.hs
2147         @test -n "$(HLINT)" || { echo 'hlint' not found during configure; exit 1; }
2148         @rm -f doc/hs-lint.html
2149         if tty -s; then C="-c"; else C=""; fi; \
2150         $(HLINT) --utf8 --report=doc/hs-lint.html --cross $$C \
2151           --ignore "Use first" \
2152           --ignore "Use &&&" \
2153           --ignore "Use void" \
2154           --ignore "Reduce duplication" \
2155           --hint src/lint-hints \
2156           $(filter-out $(HLINT_EXCLUDES),$(HS_LIBTEST_SRCS) $(HS_PROG_SRCS))
2157         @if [ ! -f doc/hs-lint.html ]; then \
2158           echo "All good" > doc/hs-lint.html; \
2159         fi
2160
2161 # a dist hook rule for updating the vcs-version file; this is
2162 # hardcoded due to where it needs to build the file...
2163 dist-hook:
2164         $(MAKE) $(AM_MAKEFLAGS) regen-vcs-version
2165         rm -f $(top_distdir)/vcs-version
2166         cp -p $(srcdir)/vcs-version $(top_distdir)
2167
2168 # a distcheck hook rule for catching revision control directories
2169 distcheck-hook:
2170         if find $(top_distdir) -name .svn -or -name .git | grep .; then \
2171           echo "Found revision control files in final archive." 1>&2; \
2172           exit 1; \
2173         fi
2174         if find $(top_distdir) -name '*.py[co]' | grep .; then \
2175           echo "Found Python byte code in final archive." 1>&2; \
2176           exit 1; \
2177         fi
2178         if find $(top_distdir) -name '*~' | grep .; then \
2179           echo "Found backup files in final archive." 1>&2; \
2180           exit 1; \
2181         fi
2182 # Empty files or directories should not be distributed. They can cause
2183 # unnecessary warnings for packagers. Directories used by automake during
2184 # distcheck must be excluded.
2185         if find $(top_distdir) -empty -and -not \( \
2186             -path $(top_distdir)/_build -or \
2187             -path $(top_distdir)/_inst \) | grep .; then \
2188           echo "Found empty files or directories in final archive." 1>&2; \
2189           exit 1; \
2190         fi
2191         if test -e $(top_distdir)/doc/man-html; then \
2192           echo "Found documentation including man pages in final archive" >&2; \
2193           exit 1; \
2194         fi
2195
2196 # Backwards compatible distcheck-release target
2197 distcheck-release: distcheck
2198
2199 distrebuildcheck: dist
2200         set -e; \
2201         builddir=$$(mktemp -d $(abs_srcdir)/distrebuildcheck.XXXXXXX); \
2202         trap "echo Removing $$builddir; cd $(abs_srcdir); rm -rf $$builddir" EXIT; \
2203         cd $$builddir; \
2204         tar xzf $(abs_srcdir)/$(distdir).tar.gz; \
2205         cd $(distdir); \
2206         ./configure; \
2207         $(MAKE) maintainer-clean; \
2208         cp $(abs_srcdir)/vcs-version .; \
2209         ./configure; \
2210         $(MAKE) $(AM_MAKEFLAGS)
2211
2212 dist-release: dist
2213         set -e; \
2214         for i in $(DIST_ARCHIVES); do \
2215           echo -n "Checking $$i ... "; \
2216           autotools/check-tar < $$i; \
2217           echo OK; \
2218         done
2219
2220 install-exec-local:
2221         @mkdir_p@ "$(DESTDIR)${localstatedir}/lib/ganeti" \
2222           "$(DESTDIR)${localstatedir}/log/ganeti" \
2223           "$(DESTDIR)${localstatedir}/run/ganeti"
2224         for dir in $(SYMLINK_TARGET_DIRS); do \
2225           @mkdir_p@  $(DESTDIR)$$dir; \
2226         done
2227         $(LN_S) -f $(sysconfdir)/ganeti/lib $(DESTDIR)$(defaultversiondir)
2228         $(LN_S) -f $(sysconfdir)/ganeti/share $(DESTDIR)$(defaultversionedsharedir)
2229         for prog in $(HS_BIN_ROLES); do \
2230           $(LN_S) -f $(defaultversiondir)$(exec_prefix)/bin/$$prog $(DESTDIR)$(exec_prefix)/bin/$$prog; \
2231         done
2232         $(LN_S) -f $(defaultversiondir)$(libdir)/ganeti/iallocators/hail $(DESTDIR)$(libdir)/ganeti/iallocators/hail
2233         for prog in $(all_sbin_scripts); do \
2234           $(LN_S) -f $(defaultversiondir)$(exec_prefix)/sbin/$$prog $(DESTDIR)$(exec_prefix)/sbin/$$prog; \
2235         done
2236         for prog in $(gnt_scripts_basenames); do \
2237           $(LN_S) -f $(defaultversionedsharedir)/$$prog $(DESTDIR)$(exec_prefix)/sbin/$$prog; \
2238         done
2239         for prog in $(pkglib_python_basenames); do \
2240           $(LN_S) -f $(defaultversionedsharedir)/$$prog $(DESTDIR)$(libdir)/ganeti/$$prog; \
2241         done
2242         for prog in $(tools_python_basenames); do \
2243           $(LN_S) -f $(defaultversionedsharedir)/$$prog $(DESTDIR)$(libdir)/ganeti/tools/$$prog; \
2244         done
2245         for prog in $(tools_basenames); do \
2246           $(LN_S) -f $(defaultversiondir)/$(libdir)/ganeti/tools/$$prog $(DESTDIR)$(libdir)/ganeti/tools/$$prog; \
2247         done
2248         if ! test -n '$(ENABLE_MANPAGES)'; then \
2249           for man in $(manfullpath); do \
2250             $(LN_S) -f $(defaultversionedsharedir)$(datarootdir)/man/$$man $(DESTDIR)$(datarootdir)/man/$$man; \
2251           done; \
2252         fi
2253         for prog in $(myexeclib_scripts_basenames); do \
2254           $(LN_S) -f $(defaultversiondir)$(libdir)/ganeti/$$prog $(DESTDIR)$(libdir)/ganeti/$$prog; \
2255         done
2256 if INSTALL_SYMLINKS
2257         $(LN_S) -f $(versionedsharedir) $(DESTDIR)$(sysconfdir)/ganeti/share
2258         $(LN_S) -f $(versiondir) $(DESTDIR)$(sysconfdir)/ganeti/lib
2259 endif
2260
2261 .PHONY: apidoc
2262 if WANT_HSAPIDOC
2263 apidoc: py-apidoc hs-apidoc
2264 else
2265 apidoc: py-apidoc
2266 endif
2267
2268 .PHONY: py-apidoc
2269 py-apidoc: epydoc.conf $(RUN_IN_TEMPDIR) $(GENERATED_FILES)
2270         env - PATH="$$PATH" PYTHONPATH="$$PYTHONPATH" \
2271         $(RUN_IN_TEMPDIR) epydoc -v \
2272           --conf $(CURDIR)/epydoc.conf \
2273           --output $(CURDIR)/$(APIDOC_PY_DIR)
2274
2275 .PHONY: hs-apidoc
2276 hs-apidoc: $(APIDOC_HS_DIR)/index.html
2277
2278 $(APIDOC_HS_DIR)/index.html: $(HS_LIBTESTBUILT_SRCS) Makefile
2279         @test -n "$(HSCOLOUR)" || \
2280             { echo 'HsColour' not found during configure; exit 1; }
2281         @test -n "$(HADDOCK)" || \
2282             { echo 'haddock' not found during configure; exit 1; }
2283         rm -rf $(APIDOC_HS_DIR)/*
2284         for i in $(ALL_APIDOC_HS_DIRS); do \
2285           @mkdir_p@ $$i; \
2286           $(HSCOLOUR) -print-css > $$i/hscolour.css; \
2287         done
2288         set -e ; \
2289         export LC_ALL=en_US.UTF-8; \
2290         OPTGHC="--optghc=-isrc --optghc=-itest/hs"; \
2291         if [ "$(HS_PARALLEL3)" ]; \
2292         then OPTGHC="$$OPTGHC --optghc=$(HS_PARALLEL3)"; \
2293         fi; \
2294         if [ "$(HS_REGEX_PCRE)" ]; \
2295         then OPTGHC="$$OPTGHC --optghc=$(HS_REGEX_PCRE)"; \
2296         fi; \
2297         for file in $(HS_LIBTESTBUILT_SRCS); do \
2298           f_nosrc=$${file##src/}; \
2299           f_notst=$${f_nosrc##test/hs/}; \
2300           f_html=$${f_notst%%.hs}.html; \
2301           $(HSCOLOUR) -css -anchor $$file > $(APIDOC_HS_DIR)/$$f_html ; \
2302         done ; \
2303         $(HADDOCK) --odir $(APIDOC_HS_DIR) --html --ignore-all-exports -w \
2304           -t ganeti -p src/haddock-prologue \
2305           --source-module="%{MODULE/.//}.html" \
2306           --source-entity="%{MODULE/.//}.html#%{NAME}" \
2307           $$OPTGHC \
2308           $(HS_LIBTESTBUILT_SRCS)
2309
2310 .PHONY: TAGS
2311 TAGS: $(GENERATED_FILES)
2312         rm -f TAGS
2313         $(GHC) -e ":etags" -v0 \
2314           $(filter-out -O -Werror,$(HFLAGS)) \
2315           $(HS_PARALLEL3) $(HS_REGEX_PCRE) \
2316           $(HS_LIBTEST_SRCS)
2317         find . -path './lib/*.py' -o -path './scripts/gnt-*' -o \
2318           -path './daemons/ganeti-*' -o -path './tools/*' -o \
2319           -path './qa/*.py' | \
2320           etags -l python -a -
2321
2322 .PHONY: coverage
2323
2324 COVERAGE_TESTS=
2325 if WANT_HTOOLS
2326 COVERAGE_TESTS += hs-coverage
2327 endif
2328 if PY_UNIT
2329 COVERAGE_TESTS += py-coverage
2330 endif
2331
2332 coverage: $(COVERAGE_TESTS)
2333
2334 .PHONY: py-coverage
2335 py-coverage: $(GENERATED_FILES) $(python_tests)
2336         @test -n "$(PYCOVERAGE)" || \
2337             { echo 'python-coverage' not found during configure; exit 1; }
2338         set -e; \
2339         COVERAGE=$(PYCOVERAGE) \
2340         COVERAGE_FILE=$(CURDIR)/$(COVERAGE_PY_DIR)/data \
2341         TEXT_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR)/report.txt \
2342         HTML_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR) \
2343         $(PLAIN_TESTS_ENVIRONMENT) \
2344         $(abs_top_srcdir)/autotools/gen-py-coverage \
2345         $(python_tests)
2346
2347 .PHONY: hs-coverage
2348 hs-coverage: $(haskell_tests) test/hs/hpc-htools test/hs/hpc-mon-collector
2349         rm -f *.tix
2350         $(MAKE) $(AM_MAKEFLAGS) hs-check
2351         @mkdir_p@ $(COVERAGE_HS_DIR)
2352         hpc sum --union $(HPCEXCL) \
2353           htest.tix hpc-htools.tix hpc-mon-collector.tix > coverage-hs.tix
2354         hpc markup --destdir=$(COVERAGE_HS_DIR) coverage-hs.tix
2355         hpc report coverage-hs.tix | tee $(COVERAGE_HS_DIR)/report.txt
2356         $(LN_S) -f hpc_index.html $(COVERAGE_HS_DIR)/index.html
2357
2358 # Special "kind-of-QA" target for htools, needs special setup (all
2359 # tools compiled with -fhpc)
2360 .PHONY: live-test
2361 live-test: all
2362         set -e ; \
2363         cd src; \
2364         rm -f .hpc; $(LN_S) ../.hpc .hpc; \
2365         rm -f *.tix *.mix; \
2366         ./live-test.sh; \
2367         hpc sum --union $(HPCEXCL) $(addsuffix .tix,$(HS_PROGS:src/%=%)) \
2368           --output=live-test.tix ; \
2369         @mkdir_p@ ../$(COVERAGE_HS_DIR) ; \
2370         hpc markup --destdir=../$(COVERAGE_HS_DIR) live-test \
2371           --srcdir=.. $(HPCEXCL) ; \
2372         hpc report --srcdir=.. live-test $(HPCEXCL)
2373
2374 commit-check: autotools-check distcheck lint apidoc
2375
2376 autotools-check:
2377         TESTDATA_DIR=./test/data shelltest $(SHELLTESTARGS) \
2378   $(abs_top_srcdir)/test/autotools/*-*.test \
2379   -- --hide-successes
2380
2381 .PHONY: gitignore-check
2382 gitignore-check:
2383         @if [ -n "`git status --short`" ]; then \
2384           echo "Git status is not clean!" 1>&2 ; \
2385           git status --short; \
2386           exit 1; \
2387         fi
2388
2389 # target to rebuild all man pages (both groff and html output)
2390 .PHONY: man
2391 man: $(man_MANS) $(manhtml)
2392
2393 # Target that builds all binaries (including those that are not
2394 # rebuilt except when running the tests)
2395 .PHONY: really-all
2396 really-all: all $(check_SCRIPTS) $(haskell_tests) $(HS_ALL_PROGS)
2397
2398 # we don't need the ancient implicit rules:
2399 %: %,v
2400 %: RCS/%,v
2401 %: RCS/%
2402 %: s.%
2403 %: SCCS/s.%
2404
2405 -include ./Makefile.local
2406
2407 # vim: set noet :